import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.BufferedImage;
import yoshi.imageio.ImageIOUtility;
import yoshi.layer.*;
import yoshi.layer.image.*;
import yoshi.dnd.*;

/**
* 摜\pNX
*/
public class MainPanel extends JPanel
	implements ActionListener, MouseListener, MouseMotionListener, KeyListener, FileDropListener
{
	//TODO: ̈ʒuɕϐ̐錾Ă
	private Frame parent;
	private ImageIOUtility utility;
	
	private Rectangle marker = new Rectangle();
	private Color clrMark = new Color(255,255,255,128);
	
	private boolean modifyShift = false;
	private boolean modifyCTRL = false;
	private Point lastPoint,pressPoint;
	
	private JMenuItem itemImageOpen,itemImageSave,itemOpenArc,itemShowArc;
	private JMenuItem itemEdit, itemBorder, itemLocation, itemName, itemDelete;
	private JMenuItem itemTop, itemBottom, itemLeft, itemRight;
	private JMenuItem itemSelect, itemAnd, itemOr, itemSave, itemBack, itemLevel;
	
	private LayerList layerList;
	private AreaPanel area;
	private EditDialog edit;
	private LinkListDialog linkList;
	
	/**
	* RXgN^
	*/
	public MainPanel(Frame parent){
		this.parent = parent;
		
		utility = new ImageIOUtility(parent);
		layerList = new LayerList();
		lastPoint = new Point();
		pressPoint = new Point();
		area = new AreaPanel();
		edit = new EditDialog(parent);
		linkList = new LinkListDialog(parent);
		linkList.setCellRenderer(new LayerRenderer());
		linkList.setTitle("C[̗D揇ʕύX");
		
		setDropTarget(new FileDropTarget(this));
		setBackground(Color.black);
		addMouseListener(this);
		addMouseMotionListener(this);
	}
	/**
	* `
	*/
	protected void paintComponent(Graphics g){
		g.setColor(getBackground());
		g.fillRect(0,0,getWidth(),getHeight());
		
		layerList.display(g, 0, 0, this);
		
		if(modifyShift){
			g.setColor(clrMark);
			g.fillRect(marker.x,marker.y,marker.width,marker.height);
		}
	}
	/**
	* 摜VKǉ܂B
	*/
	public void addImage(BufferedImage img){
		if(img != null){
			ImageIcon icon = new ImageIcon(img.getScaledInstance(-1,50,Image.SCALE_FAST));
			ImageLayer layer = new ImageLayer(img, icon);
			layerList.addLayer(layer, parent);
			revalidate();
			repaint();
		}
	}
	/**
	* 摜폜܂B
	*/
	public void deleteImage(int index){
		layerList.deleteLayer(index, parent);
		revalidate();
		repaint();
	}
	/**
	* I𒆂̉摜ۑ܂
	*/
	public void saveSelectedImage(){
		int index = layerList.getSelectedIndex(0);
		while(index >= 0){
			Layer layer = layerList.getLayer(index);
			int result = JOptionPane.showConfirmDialog( parent, layer.getName()+"ۑ܂H"
				, layer.getName()+"̕ۑ", JOptionPane.YES_NO_OPTION
				, JOptionPane.INFORMATION_MESSAGE, layer.getIcon() );
			
			if(result == JOptionPane.YES_OPTION){
				utility.saveImage(layer.getImage());
			}
			index = layerList.getSelectedIndex(index+1);
		}
	}
	public JMenu createMenuImage(){
		//JMenu menu = new JMenu("摜(I)");
		JMenu menu = new JMenu("摜");
		//menu.setMnemonic('I');
		
		//itemImageOpen = new JMenuItem("摜ǉ(O)");
		itemImageOpen = new JMenuItem("摜ǉ");
		//itemImageOpen.setMnemonic('O');
		itemImageOpen.addActionListener(this);
		itemImageOpen.setToolTipText("t@CJĉ摜ǉ܂");
		menu.add(itemImageOpen);
		
		//itemImageSave = new JMenuItem("摜ۑ(S)");
		itemImageSave = new JMenuItem("摜ۑ");
		//itemImageSave.setMnemonic('S');
		itemImageSave.addActionListener(this);
		itemImageSave.setToolTipText("I𒆂̉摜ۑ܂");
		menu.add(itemImageSave);
		
		menu.addSeparator();
		
		//itemOpenArc = new JMenuItem("ɂI(A)");
		itemOpenArc = new JMenuItem("ɂI");
		//itemOpenArc.setMnemonic('A');
		itemOpenArc.addActionListener(this);
		itemOpenArc.setToolTipText("ɂI܂");
		menu.add(itemOpenArc);
		
		//itemShowArc = new JMenuItem("ɂĊJ(R)");
		itemShowArc = new JMenuItem("ɂĊJ");
		//itemShowArc.setMnemonic('R');
		itemShowArc.addActionListener(this);
		itemShowArc.setToolTipText("OɊJɂJ܂");
		menu.add(itemShowArc);
		
		return menu;
	}
	public JMenu createMenuEdit(){
		//JMenu menu = new JMenu("ҏW(E)");
		JMenu menu = new JMenu("ҏW");
		//menu.setMnemonic('E');
		//popup = new JPopupMenu();
		
		//itemEdit = new JMenuItem("ҏW(E)");
		itemEdit = new JMenuItem("ҏW");
		//itemEdit.setMnemonic('E');
		itemEdit.addActionListener(this);
		itemEdit.setToolTipText("ҏWp̃_CAOJ܂");
		menu.add(itemEdit);
		//popup.add(itemEdit);
		
		menu.addSeparator();
		
		//itemBorder = new JMenuItem("g̐F(B)");
		itemBorder = new JMenuItem("g̐F");
		//itemBorder.setMnemonic('B');
		itemBorder.addActionListener(this);
		itemBorder.setToolTipText("g̐FI܂");
		menu.add(itemBorder);
		//popup.add(itemBorder);
		
		//itemLocation = new JMenuItem("ʒu(P)");
		itemLocation = new JMenuItem("ʒu");
		//itemLocation.setMnemonic('P');
		itemLocation.addActionListener(this);
		itemLocation.setToolTipText("\ʒuݒ肵܂");
		menu.add(itemLocation);
		//popup.add(itemLocation);
		
		//itemName = new JMenuItem("O(N)");
		itemName = new JMenuItem("O");
		//itemName.setMnemonic('N');
		itemName.addActionListener(this);
		itemName.setToolTipText("C[̖Oݒ肵܂");
		menu.add(itemName);
		//popup.add(itemName);
		
		menu.addSeparator();
		
		//itemDelete = new JMenuItem("폜(D)");
		itemDelete = new JMenuItem("폜");
		//itemDelete.setMnemonic('D');
		itemDelete.addActionListener(this);
		itemDelete.setToolTipText("摜폜܂");
		menu.add(itemDelete);
		//popup.add(itemDelete);
		
		return menu;
	}
	public JMenu createMenuCompose(){
		//JMenu menu = new JMenu("(C)");
		JMenu menu = new JMenu("");
		//menu.setMnemonic('C');
		
		//itemBack = new JMenuItem("wiF(B)");
		itemBack = new JMenuItem("wiF");
		//itemBack.setMnemonic('B');
		itemBack.addActionListener(this);
		itemBack.setToolTipText("wiFύX܂");
		menu.add(itemBack);
		
		//itemLevel = new JMenuItem("D揇(L)");
		itemLevel = new JMenuItem("D揇");
		//itemLevel.setMnemonic('L');
		itemLevel.addActionListener(this);
		itemLevel.setToolTipText("C[̗D揇ʂύX܂");
		menu.add(itemLevel);
		
		menu.add(createMenuSelect());
		menu.add(createMenuDress());
		
		//itemSave = new JMenuItem("摜̕ۑ(S)");
		itemSave = new JMenuItem("摜̕ۑ");
		//itemSave.setMnemonic('S');
		itemSave.addActionListener(this);
		itemSave.setToolTipText("I͈͓̍摜ۑ܂");
		menu.add(itemSave);
		
		return menu;
	}
	private JMenu createMenuSelect(){
		//JMenu menu = new JMenu("I͈(A)");
		JMenu menu = new JMenu("I͈");
		//menu.setMnemonic('A');
		
		//itemSelect = new JMenuItem("͈͕ύX(S)");
		itemSelect = new JMenuItem("͈͕ύX");
		//itemSelect.setMnemonic('S');
		itemSelect.addActionListener(this);
		itemSelect.setToolTipText("I͈͂ύX܂");
		menu.add(itemSelect);
		
		//itemAnd = new JMenuItem("AND͈(A)");
		itemAnd = new JMenuItem("AND͈");
		//itemAnd.setMnemonic('A');
		itemAnd.addActionListener(this);
		itemAnd.setToolTipText("ANDŌvZ͈͂ɕύX܂");
		menu.add(itemAnd);
		
		//itemOr = new JMenuItem("OR͈(O)");
		itemOr = new JMenuItem("OR͈");
		//itemOr.setMnemonic('O');
		itemOr.addActionListener(this);
		itemOr.setToolTipText("ORŌvZ͈͂ɕύX܂");
		menu.add(itemOr);
		
		return menu;
	}
	private JMenu createMenuDress(){
		//JMenu menu = new JMenu("(D)");
		JMenu menu = new JMenu("");
		//menu.setMnemonic('D');
		
		//itemTop = new JMenuItem("(T)");
		itemTop = new JMenuItem("");
		//itemTop.setMnemonic('T');
		itemTop.addActionListener(this);
		itemTop.setToolTipText("ł낦܂");
		menu.add(itemTop);
		
		//itemBottom = new JMenuItem("(B)");
		itemBottom = new JMenuItem("");
		//itemBottom.setMnemonic('B');
		itemBottom.addActionListener(this);
		itemBottom.setToolTipText("ł낦܂");
		menu.add(itemBottom);
		
		//itemLeft = new JMenuItem("(L)");
		itemLeft = new JMenuItem("");
		//itemLeft.setMnemonic('L');
		itemLeft.addActionListener(this);
		itemLeft.setToolTipText("ł낦܂");
		menu.add(itemLeft);
		
		//itemRight = new JMenuItem("E(R)");
		itemRight = new JMenuItem("E");
		//itemRight.setMnemonic('R');
		itemRight.addActionListener(this);
		itemRight.setToolTipText("Eł낦܂");
		menu.add(itemRight);
		
		return menu;
	}
	/**
	* JScrollPanep
	*/
	public Dimension getPreferredSize(){
		return new Dimension(layerList.getWidth(),layerList.getHeight());
	}
	public void updateUI(){
		if(utility != null) utility.updateUI();
		if(layerList != null) layerList.updateUI();
	}
	//--------- ȉXi[̎ --------------//
	/**
	* ActionListener
	*/
	public void actionPerformed(ActionEvent e){
		Object obj = e.getSource();
		if(obj == itemImageOpen){
			addImage(utility.openImage());
		}else if(obj == itemImageSave){
			saveSelectedImage();
		}else if(obj == itemOpenArc){
			addImage(utility.openArcive());
		}else if(obj == itemShowArc){
			addImage(utility.showArcive());
		}else if(obj == itemEdit){
			onItemEdit();
		}else if(obj == itemBorder){
			onItemBorder();
		}else if(obj == itemLocation){
			onItemLocation();
		}else if(obj == itemDelete){
			onItemDelete();
		}else if(obj == itemName){
			onItemName();
		}else if(obj == itemBack){
			Color c = JColorChooser.showDialog(parent, "wiFIĂ"
				, getBackground());
			if(c != null){
				setBackground(c);
			}
		}else if(obj == itemSave){
			onItemSave();
		}else if(obj == itemSelect){
			onItemSelect();
		}else if(obj == itemAnd){
			onItemAnd();
		}else if(obj == itemOr){
			onItemOr();
		}else if(obj == itemTop){
			layerList.dressTop();
		}else if(obj == itemBottom){
			layerList.dressBottom();
		}else if(obj == itemLeft){
			layerList.dressLeft();
		}else if(obj == itemRight){
			layerList.dressRight();
		}else if(obj == itemLevel){
			onItemLevel();
		}
		repaint();
	}
	/**
	* 摜̕ҏW܂
	*/
	private void onItemEdit(){
		int index = layerList.getSelectedIndex(0);
		while(index >= 0){
			Layer layer = layerList.getLayer(index);
			int result = JOptionPane.showConfirmDialog( parent, layer.getName()+"̕ҏWʂJ܂H"
				, layer.getName()+"̕ҏW", JOptionPane.YES_NO_OPTION
				, JOptionPane.QUESTION_MESSAGE, layer.getIcon() );
			
			if(result == JOptionPane.YES_OPTION){
				layer.showEditDialog(parent);
			}
			index = layerList.getSelectedIndex(index+1);
		}
	}
	/**
	* g̐Fw肵܂
	*/
	private void onItemBorder(){
		int index = layerList.getSelectedIndex(0);
		while(index >= 0){
			Layer layer = layerList.getLayer(index);
			Color c = JColorChooser.showDialog(parent, layer.getName()+"̘g̐FIĂ"
				, layer.getBorderColor());
			
			if(c != null){
				layer.setBorderColor(c);
			}
			index = layerList.getSelectedIndex(index+1);
		}
	}
	/**
	* ʒuݒ肵܂
	*/
	private void onItemLocation(){
		int index = layerList.getSelectedIndex(0);
		while(index >= 0){
			Layer layer = layerList.getLayer(index);
			area.setLocaleOnly(true);
			area.setAreaRectangle(layer);
			area.setMessage(layer.getName()+"̈ʒu̕ύXs܂");
			int result = JOptionPane.showConfirmDialog( parent, area, layer.getName()+"̈ʒu"
				, JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE, layer.getIcon() );
			if(result == JOptionPane.YES_OPTION){
				try{
					int x = area.getAreaX();
					int y = area.getAreaY();
					layer.x = x;
					layer.y = y;
				}catch(NumberFormatException e){
					JOptionPane.showMessageDialog(parent, "lŝߎ܂");
				}
			}
			index = layerList.getSelectedIndex(index+1);
		}
		layerList.checkSize();
		revalidate();
	}
	/**
	* Ow肵܂
	*/
	private void onItemName(){
		int index = layerList.getSelectedIndex(0);
		while(index >= 0){
			Layer layer = layerList.getLayer(index);
			String name = (String)JOptionPane.showInputDialog(parent, layer.getName()+"̖OύX܂"
				,layer.getName()+"̖O̕ύX", JOptionPane.INFORMATION_MESSAGE, layer.getIcon()
				, null, layer.getName() );
			if(name != null && name.length() > 0){
				layer.setName(name);
			}
			index = layerList.getSelectedIndex(index+1);
		}
	}
	/**
	* C[폜܂
	*/
	private void onItemDelete(){
		int index = layerList.getSelectedIndex(0);
		while(index >= 0){
			layerList.deleteLayer(index, parent);
			index = layerList.getSelectedIndex(index+1);
		}
		revalidate();
	}
	/**
	* 摜̕ۑ
	*/
	private void onItemSave(){
		if(marker.width <= 0 || marker.height <= 0){
			JOptionPane.showMessageDialog(parent, "̈IĂ");
			return;
		}
		int result = JOptionPane.showConfirmDialog( parent,"obNOh`܂?", "obNOEh"
				, JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
		
		if(layerList.size() > 0){
			BufferedImage OSI = new BufferedImage(marker.width,marker.height,BufferedImage.TYPE_INT_ARGB);
			Graphics OSG = OSI.getGraphics();
			if(result == JOptionPane.YES_OPTION){
				OSG.setColor(getBackground());
				OSG.fillRect(0,0,getWidth(),getHeight());
			}
			
			layerList.drawImage(OSG,-marker.x,-marker.y, this);
			
			utility.saveImage(OSI);
		}
	}
	/**
	* Ïݒ肵܂
	*/
	private void onItemSelect(){
		area.setLocaleOnly(false);
		area.setAreaRectangle(marker);
		area.setMessage("Ï̐ݒs܂");
		int result = JOptionPane.showConfirmDialog( parent, area, "Ï"
				, JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE);
		
		if(result == JOptionPane.OK_OPTION){
			try{
				Rectangle rect = area.getAreaRectangle();
				if(rect.width < 0 || rect.height < 0){
					JOptionPane.showMessageDialog(parent, "傫̂ߎ܂");
				}else{
					marker = rect;
				}
			}catch(NumberFormatException e){
				JOptionPane.showMessageDialog(parent, "lŝߎ܂");
			}
		}
	}
	/**
	* I͈͂ANDZŌvZ܂
	*/
	private void onItemAnd(){
		int result = JOptionPane.showConfirmDialog( parent, "ÏANDvZŌ߂܂"
			, "Ï", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
		
		if(result == JOptionPane.YES_OPTION){
			marker = layerList.getIntersectionRectangle();
		}
	}
	/**
	* I͈͂ORZŌvZ܂
	*/
	private void onItemOr(){
		int result = JOptionPane.showConfirmDialog( parent, "ÏORvZŌ߂܂"
			, "Ï", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
		if(result == JOptionPane.YES_OPTION){
			marker = layerList.getUnionRectangle();
		}
	}
	/**
	* D揇ʂ߂܂
	*/
	private void onItemLevel(){
		if(layerList.size() > 1){
			linkList.setListData(layerList.getLayers());
			linkList.setVisible(true);
			if(linkList.isChange()){
				layerList.setLayerLevel(linkList.getLinkList());
				repaint();
			}
		}
	}
	public void dropFiles(File[] files){
		if(files != null && files.length > 0){
			for(int i=0;i<files.length;i++){
				try{
					addImage(utility.openFile(files[i]));
				}catch(IOException ie){
					JOptionPane.showMessageDialog(parent, files[i].getName() + "͊J܂łB");
				}
			}
		}
	}
	/**
	* MouseListener
	*/
	public void mouseClicked(MouseEvent e) {
		//if(SwingUtilities.isLeftMouseButton(e)){
			if(modifyShift){
				
			}else{
				layerList.mouseClicked(e.getPoint(), lastPoint, modifyCTRL);
			}
			lastPoint = e.getPoint();
			repaint();
		//}else{
		//	popup.show(this, e.getX(), e.getY());
		//}
	}
	public void mousePressed(MouseEvent e) {
		//if(SwingUtilities.isLeftMouseButton(e)){
			if(modifyShift){
				marker.setBounds(e.getX(),e.getY(),0,0);
				pressPoint = e.getPoint();
			}else{
				layerList.mousePressed(e.getPoint(), lastPoint, modifyCTRL);
			}
			lastPoint = e.getPoint();
			repaint();
		//}
	}
	public void mouseReleased(MouseEvent e) {
		//if(SwingUtilities.isLeftMouseButton(e)){
			if(modifyShift){
				marker.setBounds(e.getX(),e.getY(),0,0);
				marker.add(pressPoint);
			}else{
				layerList.mouseReleased(e.getPoint(), lastPoint, modifyCTRL);
			}
			lastPoint = e.getPoint();
			revalidate();
			repaint();
		//}
	}
	/**
	* MouseMotionListener
	*/
	public void mouseDragged(MouseEvent e) {
		//if(SwingUtilities.isLeftMouseButton(e)){
			if(modifyShift){
				marker.setBounds(e.getX(),e.getY(),0,0);
				marker.add(pressPoint);
			}else{
				layerList.mouseDragged(e.getPoint(), lastPoint, modifyCTRL);
			}
			lastPoint = e.getPoint();
			repaint();
		//}
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {}
	
	/**
	* KeyListener
	*/
	public void keyPressed(KeyEvent e) {
		switch(e.getKeyCode()){
		case KeyEvent.VK_SHIFT:
			if(!modifyShift){
				modifyShift = true;
				repaint();
			}
			break;
		case KeyEvent.VK_CONTROL:
			modifyCTRL = true;
			break;
		}
	}
	public void keyReleased(KeyEvent e) {
		switch(e.getKeyCode()){
		case KeyEvent.VK_SHIFT:
			modifyShift = false;
			repaint();
			break;
		case KeyEvent.VK_CONTROL:
			modifyCTRL = false;
			break;
		}
	}
	public void keyTyped(KeyEvent e) {}
}
