package yoshi.dnd;

import java.util.List;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.io.*;

public class FileDropTarget extends DropTarget
	implements Runnable
{
	private FileDropListener listener = null;
	private File[] files = null;
	
	public FileDropTarget(FileDropListener listener){
		this.listener = listener;
	}
	public void run(){
		if(files != null){
			listener.dropFiles(files);
		}
	}
	public void drop(DropTargetDropEvent dtde) {
		//System.out.println(dtde);
		dtde.acceptDrop(dtde.getDropAction());
		Transferable trans = dtde.getTransferable();
		DataFlavor[] flavors = trans.getTransferDataFlavors();
		for(int i=0;i<flavors.length;i++){
			if (flavors[i].isFlavorJavaFileListType()) {
				try{
					List list = (List) trans.getTransferData(flavors[i]);
					//for(int j=0;j<list.size();j++){
					//	System.out.println(list.get(j));
					//}
					if(list.size() > 0){
						files = new File[list.size()];
						for(int j=0;j<list.size();j++){
							files[j] = (File)list.get(j);
						}
						(new Thread(this)).start();
					}
				}catch(UnsupportedFlavorException ufe){
					System.out.println(ufe);
				}catch(IOException ioe){
					System.out.println(ioe);
				}
				break;
			}
		}
		dtde.dropComplete(true);
		super.drop(dtde);
	}

}