package yoshi.editmenu;

import java.awt.image.BufferedImage;

public class ImageCache
{
	private BufferedImage[] imgs;
	private int index,redoMax;
	private BufferedImage initImage;
	
	public ImageCache(BufferedImage initImage, int max){
		imgs = new BufferedImage[max];
		this.initImage = initImage;
		reset();
		add(initImage);
	}
	public void reset(){
		index = -1;
		redoMax = -1;
	}
	public void add(BufferedImage img){
		if(index >= imgs.length-1){
			index = imgs.length-1;
			for(int i=1;i<index;i++){
				imgs[i] = imgs[i+1];
			}
			imgs[index] = img;
		}else{
			index++;
			imgs[index] = img;
			//System.out.println("Add "+index);
		}
		if(redoMax < index){
			redoMax = index;
		}
	}
	public boolean canUndo(){
		return (index > 0);
	}
	public boolean canRedo(){
		return (redoMax > index);
	}
	public BufferedImage undo(){
		if(canUndo()){
			index--;
			//System.out.println("Undo "+index);
			return imgs[index];
		}else{
			return null;
		}
	}
	public BufferedImage redo(){
		if(canRedo()){
			index++;
			return imgs[index];
		}else{
			return null;
		}
	}
	public BufferedImage getImage(){
		if(index < 0){
			return initImage;
		}else{
			return imgs[index];
		}
	}
}
