//Written by JavaMaker
//DrawPanel.java
package yoshi.editmenu;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.BufferedImage;

public class ViewPanel extends JPanel
	implements ActionListener
{
	private BufferedImage img;
	private int width,height,amp;
	
	private JMenuItem info,back;
	private JRadioButtonMenuItem view1,view2,view4;
	
	private Frame parent;
	
	public ViewPanel(Frame parent) {
		this.parent = parent;
		width = 0;
		height = 0;
		amp = 1;
		setLayout(null);
		setBackground(Color.black);
	}
	
	public void setImage(BufferedImage img){
		checkImage(img);
	}
	protected void checkImage(BufferedImage img){
		this.img = img;
		if(img == null){
			width = 0;
			height = 0;
		}else{
			width = img.getWidth(this);
			height = img.getHeight(this);
		}
		revalidate();
	}
	
	public BufferedImage getImage(){
		return img;
	}

	public Point getImagePoint(Point p){
		return new Point(p.x/amp,p.y/amp);
	}
	public Rectangle getImageRectangle(Rectangle rect){
		return new Rectangle(rect.x/amp,rect.y/amp,rect.width/amp,rect.height/amp);
	}

	public JMenu createMenuView(){
		JMenu menu = new JMenu("\");
		
		info = new JMenuItem("摜");
		info.addActionListener(this);
		menu.add(info);
		
		back = new JMenuItem("wiF");
		back.addActionListener(this);
		menu.add(back);
		
		menu.addSeparator();
		
		ButtonGroup group = new ButtonGroup();
		view1 = new JRadioButtonMenuItem("ʏ");
		view1.addActionListener(this);
		group.add(view1);
		menu.add(view1);
		
		view2 = new JRadioButtonMenuItem("Q{\");
		view2.addActionListener(this);
		group.add(view2);
		menu.add(view2);
		
		view4 = new JRadioButtonMenuItem("S{\");
		view4.addActionListener(this);
		group.add(view4);
		menu.add(view4);
		
		view1.setSelected(true);
		
		return menu;
	}
	protected void paintComponent(Graphics g){
		g.setColor(getBackground());
		g.fillRect(0,0,getWidth(),getHeight());
		if(img != null){
			g.drawImage(img,0,0,width*amp,height*amp,this);
		}
	}
	public Dimension getPreferredSize(){
		return new Dimension(width*amp,height*amp);
	}
	
	public void actionPerformed(ActionEvent e) {
		Object obj = e.getSource();
		if(obj == info){
			JOptionPane.showMessageDialog(parent
				,new JLabel("width="+width+" height="+height,JLabel.CENTER)
				,"摜",JOptionPane.INFORMATION_MESSAGE);
		}else if(obj == back){
			Color back = JColorChooser.showDialog(parent,"wiF̑I",getBackground());
			if(back != null){
				setBackground(back);
			}
		}else if(obj == view1){
			if(amp != 1){
				amp = 1;
				revalidate();
			}
		}else if(obj == view2){
			if(amp != 2){
				amp = 2;
				revalidate();
			}
		}else if(obj == view4){
			if(amp != 4){
				amp = 4;
				revalidate();
			}
		}
		repaint();
	}
}
