package yoshi.editmenu.decrease;

import java.util.*;

/**
* ColorBox
*/
public class ColorBox
	implements Comparable
{
	private static ColorPackComparator comparator = new ColorPackComparator();
	
	private ColorPack[] colorPack;	//ĂF
	private int[] RGBMax = new int[3]; //RGBeX̍ől
	private int[] RGBMin = new int[3];	//RGBeX̍ŏl
	private int number; //F̑
	private boolean canCut = true;
//	private int minLength = 0;
	private int max,min;
	
	/**
	* RXgN^
	*/
	public ColorBox(ColorPack[] colorPack){
		this.colorPack = colorPack;
		setArea();
		setNumber();
	}
	/**
	* F̑
	*/
	public int getNumber(){
		return number;
	}
	public boolean canCut(){
		return canCut;
	}
	public void setCanCut(boolean canCut){
		this.canCut = canCut;
	}
	/**
	* \Ȃɕ̂Ԃ
	*/
	public ColorBox cut(){
		int mode = 0;
		int len = 0;
		//ԒƂT
		for(int i=0;i<3;i++){
			int lenTemp = RGBMax[i] - RGBMin[i];
			if(len <= lenTemp){
				len = lenTemp;
				mode = i;
			}
		}
		//ǂ؂Ƃ낪ȂƂ
		if(len <= 0){
			canCut = false;
			return null;
		}
		//\[eBO
		ColorPack.compareMode = mode;
		Arrays.sort(colorPack, comparator);
		int n = 0;
		
		//؂ꏊT
		int size = colorPack.length;
		int point = -1;
		int n2 = number/2;
		for(int i=0;i<size;i++){
			int temp = colorPack[i].getNumber();
			n += temp;
			if(n >= n2){
				if((n-n2) < (n2-n+temp)){
					point = i+1;
				}else{
					point = i;
				}
				break;
			}
		}
		if(point <= 0 || point >= size){
			canCut = false;
			return null;
		}
		//ɕ
		ColorPack[] c1 = new ColorPack[point];
		System.arraycopy(colorPack, 0, c1, 0, point);
		
		ColorPack[] c2 = new ColorPack[size-point];
		System.arraycopy(colorPack, point, c2, 0, size-point);

		this.colorPack = c1;
		setArea();
		setNumber();
		
		return new ColorBox(c2);
	}
	/**
	* ݏĂl̕ϒlԂ
	*/
	public int[] getAverage(){
		int size = colorPack.length;
		if(size == 1) return colorPack[0].getRGBs();
		int[] ave = new int[3];
		for(int j=0;j<3;j++){
			ave[j] = 0;
			for(int i=0;i<size;i++){
				ave[j] += colorPack[i].getRGB(j)*colorPack[i].getNumber();
			}
			ave[j] = ave[j]/number;
		}
		return ave;
	}
	/**
	* \[gp
	*/
	public boolean equals(Object o){
		if(o instanceof ColorBox){
			return equals((ColorPack)o);
		}else{
			return false;
		}
	}
	/**
	* \[gp
	*/
	public boolean equals(ColorBox c){
		if(max == c.getMax() && min == c.getMin()){
			return true;
		}else{
			return false;
		}
	}
	/**
	* \[gp
	*/
	public int compareTo(Object o){
		return compareTo((ColorBox)o);
	}
	/**
	* \[gp
	*/
	public int compareTo(ColorBox c){
		int n = c.getNumber();
		if(number > n){
			return 1;
		}else if(number < n){
			return -1;
		}else{
			int max2 = c.getMax();
			if(max < max2){
				return -1;
			}else if(max > max2){
				return 1;
			}else{
				int min2 = c.getMin();
				if(min < min2){
					return -1;
				}else if(min > min2){
					return 1;
				}else{
					return 0;
				}
			}
		}
	}
	/**
	* \[gp
	*/
	protected int getMax(){
		return max;
	}
	/**
	* \[gp
	*/
	protected int getMin(){
		return min;
	}
	public String toString(){
		String temp = String.valueOf(number)+":";
		for(int i=0;i<3;i++){
			temp += String.valueOf(RGBMin[i]) + "->"+String.valueOf(RGBMax[i])+":";
		}
		return temp;
	}

	//֐
	/**
	* ̌vZ
	*/
	private void setNumber(){
		number = 0;
		int n = colorPack.length;
		for(int i=0;i<n;i++){
			number += colorPack[i].getNumber();
		}
	}
	/**
	* ͈͂ݒ肵܂
	*/
	private void setArea(){
		for(int i=0;i<3;i++){
			RGBMax[i] = 0;
			RGBMin[i] = 255;
		}
		int n = colorPack.length;
		for(int j=0;j<n;j++){
			for(int i=0;i<3;i++){
				int temp = colorPack[j].getRGB(i);
				if(RGBMax[i] < temp) RGBMax[i] = temp;
				if(RGBMin[i] > temp) RGBMin[i] = temp;
			}
		}
		max = (RGBMax[2] << 16) | (RGBMax[1] << 8) | RGBMax[0];
		min = (RGBMin[2] << 16) | (RGBMin[1] << 8) | RGBMin[0];
	}
}

