package yoshi.editmenu.kernel;

import java.awt.*;
import java.awt.image.*;
import javax.swing.SwingUtilities;

import yoshi.editmenu.EditMenuItem;

public class KernelItem extends EditMenuItem
{
	private KernelDialog dialog;
	private Frame parent;
	
	public KernelItem(String name){
		super(name);
	}
	public BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect){
		if(this.parent == null || this.parent != parent){
			dialog = new KernelDialog(parent);
			this.parent = parent;
		}
		dialog.setVisible(true);
		if(dialog.isSelected()){
			Kernel kernel = dialog.getKernel();
			if(kernel != null){
				ConvolveOp op = new ConvolveOp(kernel);
				if(dialog.isCheckAlpha()){
					img = checkAlpha(img);
				}
				return op.filter(img,null);
			}
		}
		return null;
	}
	/**
	* AlphaĂƂ͂܂Ȃ
	*/
	protected BufferedImage checkAlpha(BufferedImage img){
		ColorModel model = img.getColorModel();
		if(model.getAlpha(0) == 255){ //At@ȂƂ
			return img;
		}else{
			int[] pixel = img.getRGB(0,0,img.getWidth(),img.getHeight(),null,0,img.getWidth());
			return createBufferedImage(pixel,img.getWidth(),img.getHeight(),false,null);
		}
	}
	public void updateUI(){
		super.updateUI();
		if(dialog != null) SwingUtilities.updateComponentTreeUI(dialog);
	}
}
