//Written by JavaMaker
//MyFileChooser.java
package yoshi.imageio;

import java.awt.Frame;
import java.awt.image.BufferedImage;
import java.io.*;
import javax.swing.JOptionPane;

import yoshi.imageio.filefilter.ImageFileFilter;
import yoshi.imageio.filedialog.JImageChooser;

public class BufferedImageDecoder extends JImageChooser
{
	private ImageFileFilterFactory factory;
	private BufferedImage img;
	
	public BufferedImageDecoder(Frame parent,ImageFileFilterFactory factory){
		super(parent,factory.getReaderImageFileFilters(),new File("."));
		this.factory = factory;
		setTitle("BufferedImageDecoder");
	}
	public BufferedImage getImage(){
		return img;
	}
	public void approveSelection(){
		if(panel.getImage() != null){
			img = panel.getImage();
		}else if(chooser.getSelectedFile() != null){
			File file = chooser.getSelectedFile();
			ImageFileFilter filter = factory.getReaderImageFileFilter(parent,file);
			if(filter != null){
				try{
					img = filter.read(parent,new FileInputStream(file));
				}catch(FileNotFoundException e){
					JOptionPane.showMessageDialog(parent, e);
				}catch(IOException ie){
					JOptionPane.showMessageDialog(parent, ie);
				}
			}else{
				JOptionPane.showMessageDialog(parent,"\"" + file.getName() + "\"͊J܂łB"
					,"ǂݍݎs",JOptionPane.INFORMATION_MESSAGE);
			}
		}else{
			img = null;
		}
		setVisible(false);
	}
	public void cancelSelection(){
		img = null;
		setVisible(false);
	}
}
