//Written by JavaMaker
//MyFileChooser.java
package yoshi.imageio;

import java.awt.Frame;
import java.awt.image.BufferedImage;
import java.io.*;
import javax.swing.JOptionPane;

import yoshi.imageio.filefilter.ImageFileFilter;
import yoshi.imageio.filedialog.JImageChooser;

public class BufferedImageEncoder extends JImageChooser
{
	private ImageFileFilterFactory factory;
	private BufferedImage img;
	
	public BufferedImageEncoder(Frame parent,ImageFileFilterFactory factory){
		super(parent,factory.getWriterImageFileFilters(),new File("."));
		this.factory = factory;
		chooser.setDialogType(javax.swing.JFileChooser.SAVE_DIALOG);
		setTitle("BufferedImageEncoder");
	}
	public void setImage(BufferedImage img){
		this.img = img;
	}
	
	public void approveSelection(){
		ImageFileFilter filter = (ImageFileFilter)chooser.getFileFilter();
		if(!filter.canWrite()){
			setVisible(false);
			return;
		}
		if(img == null){
			setVisible(false);
			return;
		}
		
		File file = chooser.getSelectedFile();
		//㏑mF
		if(file.exists()){
			int result = JOptionPane.showConfirmDialog(parent,file.getAbsolutePath()
				+"݂͑܂B㏑܂?","㏑",JOptionPane.YES_NO_OPTION );
			if(result == JOptionPane.NO_OPTION){
				setVisible(false);
				return;
			}
		}
		if(filter.setWriteParam(parent,img)){
			file = filter.setExtention(file);
			//long st = System.currentTimeMillis();
			OutputStream out = null;
			try{
				//out = new BufferedOutputStream(new FileOutputStream(file));
				out = new FileOutputStream(file);
			}catch(FileNotFoundException e){
				JOptionPane.showMessageDialog(parent, e);
				return;
			}
			try{
				filter.write(out);
			}catch(IOException e){
				JOptionPane.showMessageDialog(parent, e);
			}
			//long et = System.currentTimeMillis();
			//System.out.println("write "+(et-st));
		}
		setVisible(false);
	}
}
