package yoshi.imageio;

import java.util.*;
import java.awt.Frame;
import yoshi.imageio.arcivefilter.*;
import javax.swing.*;
import java.io.File;

//import yoshi.imageio.arciver.SPIArciveFilterFactory;

public class ImageArciveFilterFactory
{
	private ImageArciveFilter[] filters;
	
	public ImageArciveFilterFactory(){
		Vector list = new Vector();
		defaultList(list);
		//spiList(list);
		
		filters = new ImageArciveFilter[list.size()];
		list.copyInto(filters);
	}
	public ImageArciveFilter[] getImageArciveFilters(){
		return filters;
	}
	public ImageArciveFilter getImageArciveFilter(Frame parent,File file){
		Vector v = new Vector();
		for(int i=0;i<filters.length;i++){
			if(filters[i].accept(file) && filters[i].isSupport(file)){
				v.add(filters[i]);
			}
		}
		if(v.size() > 1){
			JList list = new JList(v);
			list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			list.setSelectedIndex(0);
			int result = JOptionPane.showConfirmDialog(parent,list,"tB^̑I",
				JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE);
			if(result ==  JOptionPane.OK_OPTION ){
				return (ImageArciveFilter)list.getSelectedValue();
			}else{
				return null;
			}
		}else if(v.size() == 1){
			return (ImageArciveFilter)v.get(0);
		}else{
			return null;
		}
	}
	
	private void defaultList(List list){
		list.add(new AllArciveFilter());
		list.add(new DirectoryFilter());
		list.add(new ZIPArciveFilter());
	}
/*	private void spiList(List list){
		if(SPIArciveFilterFactory.canUse()){
			ImageArciveFilter[] filter = (new SPIArciveFilterFactory()).getArciveFilter();
			for(int i=0;i<filter.length;i++){
				list.add(filter[i]);
			}
		}
	}*/
}
