//Written by JavaMaker
//ImageIOUtility.java
package yoshi.imageio;

import java.awt.Frame;
import java.awt.image.BufferedImage;
import javax.swing.SwingUtilities;
import java.io.*;
import yoshi.imageio.arcivedialog.*;
import yoshi.imageio.filefilter.ImageFileFilter;
import yoshi.imageio.arcivefilter.ImageArciveFilter;

public class ImageIOUtility
{
	//TODO: ̈ʒuɕϐ̐錾Ă
	private ImageFileFilterFactory fileFilterFactory;
	private ImageArciveFilterFactory arcFilterFactory;
	private BufferedImageDecoder decoder;
	private BufferedImageEncoder encoder;
	private ArciveChooser arcChooser;
	private ArciverDialog arcDialog;
	private Frame parent;
	
	public ImageIOUtility(Frame parent){
		this.parent = parent;
		fileFilterFactory = new ImageFileFilterFactory();
		arcFilterFactory = new ImageArciveFilterFactory();
		decoder = new BufferedImageDecoder(parent,fileFilterFactory);
		encoder = new BufferedImageEncoder(parent,fileFilterFactory);
		arcChooser = new ArciveChooser(parent,arcFilterFactory);
		arcDialog = new DefaultArciverDialog(parent,fileFilterFactory);
	}
	public BufferedImage openImage(){
		decoder.setVisible(true);
		return decoder.getImage();
	}
	public void saveImage(BufferedImage img){
		if(img != null){
			encoder.setImage(img);
			encoder.setVisible(true);
			encoder.setImage(null);
		}
	}
	public BufferedImage openFile(File file) throws IOException{
		ImageFileFilter filter = fileFilterFactory.getReaderImageFileFilter(parent,file);
		if(filter != null){
			FileInputStream in;
			try{
				in = new FileInputStream(file);
			}catch(FileNotFoundException e){
				return null;
			}
			return filter.read(parent,new BufferedInputStream(in));
		}else{
			ImageArciveFilter arcFilter = arcFilterFactory.getImageArciveFilter(parent,file);
			if(arcFilter != null){
				arcDialog.setImageArciver(arcFilter.createImageArciver(file));
				return showArcive();
			}else{
				return null;
			}
		}
	}
	public BufferedImage openArcive(){
		arcChooser.setVisible(true);
		if(arcChooser.isSelected()){
			arcDialog.setImageArciver(arcChooser.getImageArciver());
			return showArcive();
		}else{
			return null;
		}
	}
	public BufferedImage showArcive(){
		arcDialog.setVisible(true);
		if(arcDialog.isSelected()){
			return arcDialog.getImage();
		}else{
			return null;
		}
	}
	public void updateUI(){
		if(decoder != null) SwingUtilities.updateComponentTreeUI(decoder);
		if(encoder != null) SwingUtilities.updateComponentTreeUI(encoder);
		if(arcChooser != null) SwingUtilities.updateComponentTreeUI(arcChooser);
		if(arcDialog != null) SwingUtilities.updateComponentTreeUI(arcDialog);
		if(fileFilterFactory != null) fileFilterFactory.updateUI();
	}
}
