//Written by JavaMaker
//PAKApp.java
package yoshi.imageio.arcivedialog;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;
import java.awt.image.BufferedImage;

import yoshi.imageio.ImageFileFilterFactory;
import yoshi.imageio.filefilter.ImageFileFilter;
import yoshi.imageio.arciver.ImageArciver;

public class DefaultArciverDialog extends ArciverDialog
	implements ActionListener,ListSelectionListener
{
	//TODO: ̈ʒuɕϐ̐錾Ă
	private JList list;
	private ImageArciver arc;
	private DrawPanel panel;
	private int now;
	private JButton save,ok,cancel,saveAs;
	private JComboBox cboFilter;
	private boolean isSelected = false;
	private FilePack[] filePack;
	private Frame parent;
	private ImageFileFilterFactory factory;
	
	/**
	* RXgN^
	*/
	public DefaultArciverDialog(Frame parent,ImageFileFilterFactory factory) {
		super(parent);
		this.parent = parent;
		this.factory = factory;
		initComponents();
		setLocationRelativeTo(parent);
	}
	public void setImageArciver(ImageArciver arc){
		if(this.arc != null){
			this.arc.close();
		}
		this.arc = arc;
		panel.setImage(null);
		
		if(arc != null){
			setTitle("A[JCuWJ_CAO "+arc.toString());
			String[] name = arc.getName();
			if(name != null){
				filePack = new FilePack[name.length];
				for(int i=0;i<filePack.length;i++){
					//System.out.println(name[i]);
					filePack[i] = new FilePack(name[i],i);
				}
				changeList();
			}else{
				this.arc.close();
				this.arc = null;
			}
		}
	}
	public String getArciverName(){
		if(arc != null){
			return arc.toString();
		}else{
			return null;
		}
	}
	
	public void setVisible(boolean isVisible){
		if(arc != null){
			super.setVisible(isVisible);
		}
	}
	/**
	* OKꂽ
	*/
	public boolean isSelected(){
		return isSelected;
	}
	/**
	* 摜擾܂
	*/
	public BufferedImage getImage(){
		return panel.getImage();
	}
	private void initComponents() {
		//TODO: ɏ̏Ă
		getContentPane().setLayout(new BorderLayout());
		setTitle("A[JCuWJ_CAO");
		setSize(700,500);
		
		getContentPane().add(createWest(),BorderLayout.WEST);
		panel = new DrawPanel();
		getContentPane().add(new JScrollPane(panel),BorderLayout.CENTER);
		getContentPane().add(createSouth(),BorderLayout.SOUTH);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				isSelected = false;
				setVisible(false);
			}
		});
		list.addListSelectionListener(this);
	}
	private Component createWest(){
		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());
		list = new JList();
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		now = -1;
		p.add(new JScrollPane(list),BorderLayout.CENTER);
		cboFilter = new JComboBox(factory.getReaderImageFileFilters());
		cboFilter.addActionListener(this);
		p.add(cboFilter,BorderLayout.NORTH);
		return p;
	}
	private Component createSouth(){
		JPanel p = new JPanel();
		p.setLayout(new GridLayout(1,3));
		ok = new JButton("");
		ok.addActionListener(this);
		p.add(ok);
		
		cancel = new JButton("");
		cancel.addActionListener(this);
		p.add(cancel);
		
		save = new JButton("̂܂ܕۑ");
		save.addActionListener(this);
		p.add(save);
		
		//saveAs = new JButton("`Iĕۑ");
		//saveAs.addActionListener(this);
		//p.add(saveAs);
		
		return p;
	}
	public void actionPerformed(ActionEvent e){
		Object obj = e.getSource();
		if(obj == save){
			OnFileSave();
		}else if(obj == ok){
			isSelected = true;
			setVisible(false);
		}else if(obj == cancel){
			isSelected = false;
			setVisible(false);
		}else if(obj == cboFilter){
			now = -1;
			changeList();
		}
		repaint();
	}
	private int getNumber(){
		FilePack temp = (FilePack)list.getSelectedValue();
		if(temp == null){
			return -1;
		}else{
			return temp.getNumber();
		}
	}
	private void OnFileSave() {
		//TODO: SaveIꂽƂ̏ĉB
		if(!arc.isSupported()) return;
		JFileChooser chooser = new JFileChooser(new File(" "));
		int n = getNumber();
		if(n < 0) return;
		chooser.setSelectedFile(new File(arc.getName(n)));
		if(chooser.showSaveDialog(this) != JFileChooser. APPROVE_OPTION) return;
		
		//byte[] buff = arc.getData(now);
		InputStream in = arc.getInputStream(now);
		
		if(in == null) return;
		FileOutputStream out;
		try{
			out = new FileOutputStream(chooser.getSelectedFile());
		}catch(FileNotFoundException e){
			return;
		}
		try{
			byte[] buff = new byte[in.available()];
			in.read(buff);
			out.write(buff);
			out.close();
			in.close();
		}catch(IOException e){
			e.printStackTrace();
			return;
		}
	}
	private void changeList(){
		ImageFileFilter filter = getFileFilter();
		Vector v = new Vector();
		for(int i=0;i<filePack.length;i++){
			if(filter.accept(null,filePack[i].toString())){
				v.add(filePack[i]);
			}
		}
		list.setListData(v);
	}
	public void valueChanged(ListSelectionEvent e) {
		int n = getNumber();
		if(n < 0) return;
		if(now == n) return;
		now = n;
		InputStream in = arc.getInputStream(now);
		if(in == null){
			panel.setImage(null);
		}else{
			BufferedImage img = getFileFilter().read(parent,in);
			panel.setImage(img);
		}
		repaint();
	}
	private ImageFileFilter getFileFilter(){
		return (ImageFileFilter)cboFilter.getSelectedItem();
	}
}
