package yoshi.imageio.arcivefilter;

import yoshi.imageio.arciver.*;

import java.io.*;

public class SPIArciveFilter extends ImageArciveFilter
{
	private String spiName = null;
	private String ext = null;
	private String description = null;
	
	public SPIArciveFilter(String spiName,String ext,String description){
		this.spiName = spiName;
		this.ext = ext;
		this.description = description + "(." + ext + ") by " +  createName(spiName);
	}
	
	private String createName(String str){
		int n = str.lastIndexOf('/');
		if(n >= 0){
			str = str.substring(n+1);
		}
		n = str.lastIndexOf('.');
		if(n >= 0){
			str = str.substring(0,n);
		}
		return str;
	}
	public boolean isSupport(File file){
		//return SPIArciver.isSupport(file,spiName);
		return file.isFile();
	}
	public ImageArciver createImageArciver(File file){
		return new SPIArciver(file,spiName);
	}
	public String[] getExtentions(){
		return new String[]{ext};
	}
	public String getDescription(){
		return description;
	}
	public int getFileSelectionMode(){
		return javax.swing.JFileChooser.FILES_ONLY;
	}
}