//Written by JavaMaker
//ImageCuter.java
package yoshi.imageio.arciver;

import java.io.*;
import java.util.zip.*;
import java.util.Enumeration;

public class ZIPArciver extends ImageArciver

{
	private boolean isSupported = true;
	private ZipEntry[] files;
	private ZipFile file;
	private String fileName;
	
	public ZIPArciver(File parent){
		try{
			file = new ZipFile(parent);
		}catch(ZipException ze){
			isSupported = false;
			return;
		}catch(IOException ie){
			isSupported = false;
			return;
		}
		fileName = parent.getAbsolutePath();
		Enumeration e = file.entries();
		files = new ZipEntry[file.size()];
		for(int i=0;i<files.length;i++){
			files[i] = (ZipEntry)e.nextElement();
		}
	}
	public boolean isSupported(){
		return isSupported;
	}
	public int getFileCount(){
		return file.size();
	}
	public String[] getName(){
		String[] names = new String[files.length];
		for(int i=0;i<files.length;i++){
			names[i] = files[i].getName();
		}
		return names;
	}
	public String getName(int n){
		return files[n].getName();
	}
	public InputStream getInputStream(int n){
		try{
			InputStream in = file.getInputStream(files[n]);
			//System.out.println(in.available());
			//return in;
			byte[] b = new byte[in.available()];
			int offset = 0;
			while(offset < b.length){
				int len = in.read(b,offset,b.length-offset);
				if(len > 0){
					offset += len;
				}
			}
			return new ByteArrayInputStream(b);
			//return file.getInputStream(files[n]);
		}catch(IOException e){
			return null;
		}
	}
	public void close(){
		
	}
	public String toString(){
		return fileName;
	}
}