//Written by JavaMaker
//DrawPanel.java
package yoshi.imageio.filedialog;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;

public class DrawPanel extends JPanel

{
	private BufferedImage img;
	private Image view;
	
	private int width,height;
	private Dimension d;
	
	public DrawPanel(Dimension d){
		width = 0;
		height = 0;
		setLayout(null);
		setBackground(Color.black);
		this.d = d;
	}
	public void setImage(BufferedImage img){
		this.img = img;
		if(img != null){
			if(d != null){
				view = img.getScaledInstance(d.width,-1,Image.SCALE_FAST );
				width = view.getWidth(this);
				height = view.getHeight(this);
			}else{
				width = img.getWidth(this);
				height = img.getHeight(this);
			}
		}else{
			width = 0;
			height = 0;
		}
		revalidate();
	}
	public BufferedImage getImage(){
		return img;
	}
	
	protected void paintComponent(Graphics g){
		g.setColor(getBackground());
		g.fillRect(0,0,getWidth(),getHeight());
		if(img != null){
			int x = (getWidth()-width)/2;
			int y = (getHeight()-height)/2;
			if(d != null){
				g.drawImage(view,x,y,this);
			}else{
				g.drawImage(img,x,y,this);
			}
		}
	}
	public Dimension getPreferredSize(){
		return new Dimension(width,height);
	}
	public Dimension getMinimumSize(){
		if(d != null){
			return d;
		}else{
			return new Dimension(0,0);
		}
	}

}
