//Written by JavaMaker
//MyFileChooser.java
package yoshi.imageio.filedialog;

import javax.swing.*;
import java.io.*;
import java.awt.event.*;
import java.awt.*;
import java.beans.*;
import java.awt.image.BufferedImage;

import yoshi.imageio.filefilter.ImageFileFilter;

public class JImageChooser extends JDialog
	implements ActionListener,PropertyChangeListener
{
	protected JFileChooser chooser;
	protected boolean isSelectedFile = false;
	protected DrawPanel panel;
	protected Frame parent;
	
	private ImageFileFilter filter;
	private JButton unLock,btnFilter;
	private JList list;
	
	public JImageChooser(Frame parent, ImageFileFilter[] filters){
		this(parent,filters,null,false);
	}
	public JImageChooser(Frame parent, ImageFileFilter[] filters, File dir){
		this(parent,filters,dir,false);
	}
	public JImageChooser(Frame parent, ImageFileFilter[] filters, File dir, boolean useUnLockButton){
		super(parent,true);
		this.parent = parent;
		//R|[lg̏
		setTitle("JImageDialog");
		getContentPane().setLayout(new BorderLayout());
		
		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());
		
		chooser = new JFileChooser(dir);
		chooser.addActionListener(this);
		chooser.addPropertyChangeListener(this);
		p.add(chooser,BorderLayout.CENTER);
		
		if(useUnLockButton){
			JPanel p2 = new JPanel();
			p2.setLayout(new GridLayout(1,3));
			
			p2.add(new JLabel("g{^ for j2sdk_1.4.0",JLabel.CENTER));

			btnFilter = new JButton("tB^[I");
			btnFilter.addActionListener(this);
			p2.add(btnFilter);
			
			unLock = new JButton("t@CbN");
			unLock.addActionListener(this);
			p2.add(unLock,BorderLayout.SOUTH);
			
			p.add(p2,BorderLayout.SOUTH);
			
			list = new JList(filters);
		}
		
		panel = new DrawPanel(new Dimension(300,300));
		getContentPane().add(p, BorderLayout.WEST);
		getContentPane().add(new JScrollPane(panel), BorderLayout.CENTER);
		
		pack();
		setSize(getWidth()+300,getHeight());
		setLocationRelativeTo(parent);
		
		//ݒ
		chooser.setAcceptAllFileFilterUsed(false);
		for(int i=0;i<filters.length;i++){
			chooser.addChoosableFileFilter(filters[i]);
		}
		chooser.setFileFilter(filters[0]);
		filter = (ImageFileFilter)filters[0];
	}
	
	public File getSelectedFile(){
		return chooser.getSelectedFile();
	}
	
	public void approveSelection(){
		setVisible(false);
	}
	public void cancelSelection(){
		setVisible(false);
	}
	
	public void actionPerformed(ActionEvent e){
		String cmd = e.getActionCommand();
		Object obj = e.getSource();
		
		if(cmd.equals(JFileChooser.APPROVE_SELECTION)){
			if(chooser.getSelectedFile() != null){
				isSelectedFile = true;
				//setVisible(false);
				//hide();
				approveSelection();
			}
		}else if(cmd.equals(JFileChooser.CANCEL_SELECTION )){
			isSelectedFile = false;
			//setVisible(false);
			//hide();
			cancelSelection();
		}else if(obj == unLock){
			JOptionPane.showMessageDialog(chooser,"t@C̃bN܂B","bN"
				,JOptionPane.INFORMATION_MESSAGE);
		}else if(obj == btnFilter){
			int result = JOptionPane.showConfirmDialog(chooser,list,"tB^[̑I"
				,JOptionPane.OK_CANCEL_OPTION ,JOptionPane.QUESTION_MESSAGE);
			if(result == JOptionPane.OK_OPTION ){
				ImageFileFilter filter = (ImageFileFilter)list.getSelectedValue();
				if(filter != null){
					chooser.setFileFilter(filter);
				}
			}
		}
	}
	
	public void propertyChange(PropertyChangeEvent evt) {
		String prop = evt.getPropertyName();
		if(prop.equals(JFileChooser.SELECTED_FILE_CHANGED_PROPERTY)) {
			if(filter.canRead()){
				File file = chooser.getSelectedFile();
				if(file != null && file.isFile()){
					FileInputStream in;
					try{
						in = new FileInputStream(file);
					}catch(FileNotFoundException e){
						return;
					}
					try{
						panel.setImage(filter.read(parent,in));
					}catch(IOException e){
						panel.setImage(null);
					}
				}else{
					panel.setImage(null);
				}
				repaint();
			}
		}else if(prop.equals(JFileChooser.FILE_FILTER_CHANGED_PROPERTY )){
			filter = (ImageFileFilter)chooser.getFileFilter();
			panel.setImage(null);
			repaint();
		}
	}
	
	public void updateUI(){
		SwingUtilities.updateComponentTreeUI(this);
		if(chooser != null) chooser.updateUI();
	}
}
