//Written by JavaMaker
//PNGDialog.java
package yoshi.imageio.filedialog;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class PNGDialog extends JDialog
	implements ActionListener
{
	public static final int FILTER_NONE = 0;
	public static final int FILTER_SUB_ONLY = 1;
	public static final int FILTER_UP_ONLY = 2;
	public static final int FILTER_AVERAGE_ONLY = 3;
	public static final int FILTER_PAETH_ONLY = 4;
	public static final int FILTER_ABS_SUM_MIN = 5;
//	public static final int FILTER_DEFLATE_MIN = 6;
	
	private JCheckBox useAlpha,useGray,usePalette,useInter;
	private ButtonGroup filter;
	private JSlider zip;
	private JButton ok,cancel;
	private boolean isWrite = false;
	
	public PNGDialog(Frame parent) {
		super(parent,true);
		initComponents();
		setLocationRelativeTo(parent);
	}
	
	public boolean isWrite(){
		return isWrite;
	}
	
	public void actionPerformed(ActionEvent e){
		Object obj = e.getSource();
		if(obj == useGray){
			if(useGray.isSelected()) usePalette.setSelected(false);
		}else if(obj == usePalette){
			if(usePalette.isSelected()) useGray.setSelected(false);
		}else if(obj == ok){
			isWrite = true;
			setVisible(false);
		}else if(obj == cancel){
			isWrite = false;
			setVisible(false);
		}
	}
	public int getFilterLevel(){
		return Integer.parseInt(filter.getSelection().getActionCommand());
	}
	public int getCompressionLevel(){
		return zip.getValue();
	}
	public boolean getUseAlpha(){
		return useAlpha.isSelected();
	}
	public boolean getUsePalette(){
		return usePalette.isSelected();
	}
	public boolean getUseGray(){
		return useGray.isSelected();
	}
	public boolean getUseInterlace(){
		return useInter.isSelected();
	}
	public void setColorNumber(int n){
		usePalette.setEnabled(n<=256);
	}
	private void initComponents() {
		setTitle("PNG̃IvVݒ");
		setSize(500,280);
		getContentPane().setLayout(new BorderLayout(2,2));
		
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p,BoxLayout.X_AXIS));
		p.add(createOption());
		p.add(new JLabel(" "));
		p.add(createFilter());
		getContentPane().add(p,BorderLayout.CENTER);
		
		JLabel label = new JLabel("PNG̃IvVݒ",JLabel.CENTER);
		getContentPane().add(label,BorderLayout.NORTH);
		
		getContentPane().add(createSouth(), BorderLayout.SOUTH);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				setVisible(false);
			}
		});
	}
	private JPanel createSouth(){
		JPanel p = new JPanel();
		p.setLayout(new GridLayout(1,2));
		
		ok = new JButton("");
		ok.addActionListener(this);
		p.add(ok);
		
		cancel = new JButton("");
		cancel.addActionListener(this);
		p.add(cancel);
		
		return p;
	}
	private JPanel createOption(){
		JPanel p1 = new JPanel();
		p1.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"IvV"));
		p1.setLayout(new BoxLayout(p1,BoxLayout.Y_AXIS));
		
		useAlpha = new JCheckBox("At@`lgp",false);
		p1.add(useAlpha);
		
		useGray = new JCheckBox("O[XP[ɂ",false);
		useGray.addActionListener(this);
		p1.add(useGray);
		
		usePalette = new JCheckBox("CfbNXJ[gp",false);
		usePalette.addActionListener(this);
		p1.add(usePalette);
		
		useInter = new JCheckBox("C^[[Xgp",false);
		p1.add(useInter);
		
		JLabel label = new JLabel("  ");
		p1.add(label);
		
		JLabel label2 = new JLabel("Zip̈kx");
		p1.add(label2);
		
		zip = new JSlider(1,9,9);
		zip.setMajorTickSpacing(1);
		zip.setPaintTicks(true);
		zip.setSnapToTicks(true);
		zip.setPaintLabels(true);
		p1.add(zip);
		
		return p1;
	}
	private JPanel createFilter(){
		JPanel p = new JPanel();
		p.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"tB^[I"));
		p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
		filter = new ButtonGroup();
		
		JCheckBox non = new JCheckBox("tB^[Ȃ",true);
		non.setActionCommand(String.valueOf(FILTER_NONE));
		filter.add(non);
		p.add(non);
		
		JCheckBox sub = new JCheckBox("SubtB^[̂",false);
		sub.setActionCommand(String.valueOf(FILTER_SUB_ONLY));
		filter.add(sub);
		p.add(sub);
		
		JCheckBox up = new JCheckBox("UptB^[̂",false);
		up.setActionCommand(String.valueOf(FILTER_UP_ONLY));
		filter.add(up);
		p.add(up);
		
		JCheckBox average = new JCheckBox("AveragetB^[̂",false);
		average.setActionCommand(String.valueOf(FILTER_AVERAGE_ONLY));
		filter.add(average);
		p.add(average);
		
		JCheckBox paeth = new JCheckBox("PaethtB^[̂",false);
		paeth.setActionCommand(String.valueOf(FILTER_PAETH_ONLY));
		filter.add(paeth);
		p.add(paeth);
		
		JCheckBox sum = new JCheckBox("Βl̘aŏ̃tB^[I",false);
		sum.setActionCommand(String.valueOf(FILTER_ABS_SUM_MIN));
		filter.add(sum);
		p.add(sum);
		
	//	JCheckBox def = new JCheckBox("k̃TCYŏ̃tB^[I",false);
	//	def.setActionCommand(String.valueOf(FILTER_DEFLATE_MIN));
	//	filter.add(def);
	//	p.add(def);
		
		return p;
	}
}
