//Written by JavaMaker
//ImageReader.java
package yoshi.imageio.reader;

import java.awt.Point;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.awt.image.WritableRaster;
import java.awt.image.SinglePixelPackedSampleModel;
import java.awt.image.DataBuffer;
import java.awt.image.DataBufferInt;
import java.awt.image.DirectColorModel;

public abstract class ImageReader

{
	public abstract BufferedImage getImage();
	
	protected BufferedImage createBufferedImage(int[] pixel,int width,int height){
		return createBufferedImage(pixel,width,height,false,new Point());
	}
	protected BufferedImage createBufferedImage(int[] pixel,int width,int height,boolean useAlpha){
		return createBufferedImage(pixel,width,height,useAlpha,new Point());
	}
	protected BufferedImage createBufferedImage(int[] pixel,int width,int height,boolean useAlpha,Point p){
		int rmask = 0x00FF0000;
		int gmask = 0x0000FF00;
		int bmask = 0x000000FF;
		int amask = 0;
		if(useAlpha){
			amask = 0xFF000000;
			WritableRaster r = Raster.createWritableRaster(
				new SinglePixelPackedSampleModel(DataBuffer.TYPE_INT,width,height,new int[]{rmask,gmask,bmask,amask})
				,new DataBufferInt(pixel,pixel.length),p);
			return new BufferedImage(new DirectColorModel(32,rmask,gmask,bmask,amask),r,false,null);
		}else{
			WritableRaster r = Raster.createWritableRaster
				(new SinglePixelPackedSampleModel(DataBuffer.TYPE_INT,width,height,new int[]{rmask,gmask,bmask})
				,new DataBufferInt(pixel,pixel.length),p);
			return new BufferedImage(new DirectColorModel(32,rmask,gmask,bmask),r,false,null);
		}
	}

}
