//Written by JavaMaker
//PDTReader.java
package yoshi.imageio.reader;

import java.io.InputStream;
import java.io.IOException;
import java.awt.image.BufferedImage;

public class PDTReader extends ImageReader
{
	/**
	* RXgN^
	*/
	public PDTReader(InputStream in) {
		checkRead(in);
	}
	/**
	* 摜擾܂
	*/
	public BufferedImage getImage(){
		return img;
	}
	/**
	* private ϐA֐
	*/
	//PDT10
	private static byte[] header
		 = {(byte)0x50,(byte)0x44,(byte)0x54,(byte)0x31,(byte)0x30,(byte)0x00,(byte)0x00,(byte)0x00};
	private int width,height;//傫
	private BufferedImage img;
	
	private void checkRead(InputStream in){
		readData(in);
		try{
			in.close();
		}catch(IOException e){
		}
	}
	/**
	* f[^͂܂
	*/
	private void readData(InputStream in){
		//wb_ǂݍ݂܂ 8 + 4 + 4 + 4 + 8 + 4 = 32 byte
		byte[] head = new byte[32];
		try{
			in.read(head);
		}catch(IOException e){
			return;
		}
		//wb_[̃`FbN 0- 8byte
		for(int i=0;i<header.length;i++){
			if(header[i] != head[i]){
				return;
			}
		}
		int size = byteToInt(head,8); //t@C̑傫 8- 4byte
		width = byteToInt(head,12); //  12- 4byte
		height = byteToInt(head,16); //  16- 4byte
		//skip(8); // 20- 8byte
		int alpha_offset = byteToInt(head,28); //At@`l̎n܂ʒu 28- 4byte
		
		byte[] src = null; //C[W\[X
		byte[] alpha = null; //At@`l
		boolean useAlpha = false;
		
		//摜f[^̎擾
		if(alpha_offset == 0){ //At@`lȂƂ
			src = new byte[size-32];
			try{
				in.read(src);
			}catch(IOException e){
				return;
			}
		}else{	//At@`lƂ
			useAlpha = true;
			src = new byte[alpha_offset-32];
			alpha = new byte[size-alpha_offset];
			try{
				in.read(src);
				in.read(alpha);
			}catch(IOException e){
				return;
			}
		}
		int[] pixel = readImageData(src);	 //C[Wf[^ɂ܂
	
		if(useAlpha){
			readAlpha(alpha,pixel);  //At@t܂
		}
		img = createBufferedImage(pixel,width,height,useAlpha);
		
	}
	protected int byteToInt(byte[] b,int st){
		return (b[st]&0xFF)
				| ((b[st+1]&0xFF) << 8)
				| ((b[st+2]&0xFF) << 16)
				| ((b[st+3]&0xFF) << 24);
	}
	/**
	* 摜t@C͂܂
	*/
	private int[] readImageData(byte[] src){
		int srcPoint = 0; //\[X̏ꏊ
		int imgPoint = 0; //摜̏ꏊ
		int[] pixel = new int[width*height];
		
		try{
			while(true){
				byte flag = src[srcPoint++];  //J[̓ǂݎ̑I8
				int mask = 0x80;
				for(int j=0;j<8;j++){
					if((flag & mask) != 0){
						//BBGGRRǂݎ
						pixel[imgPoint++] = (src[srcPoint++]&0xFF)
							| ((src[srcPoint++]&0xFF) << 8)
							| ((src[srcPoint++]&0xFF) << 16);
					}else{
						//摜f[^̐L
						int temp = ((src[srcPoint++])&0xFF) | ((src[srcPoint++]&0xFF) << 8);//2byteɊi[
						int loop = (temp & 0x0F) + 1; //JԂ񐔁Aő16
						int paltPoint = (imgPoint - (temp >> 4) -1);  //Õpbg̎QƊJnʒu
						
						for(int i=0;i<loop;i++){
							pixel[imgPoint++] = pixel[paltPoint++]; //f[^̃Rs[
						}
					}
					mask = mask >> 1;
				}
			}
		}catch(ArrayIndexOutOfBoundsException e){}
		return pixel;
	}
	/**
	* At@`lǂݍ݂܂
	*/
	private void readAlpha(byte[] src,int[] pixel){
		int srcPoint = 0; //\[X̏ꏊ
		int imgPoint = 0; //摜̏ꏊ
		int[] alpha = new int[width*height];
		
		try{
			while(true){
				byte flag = src[srcPoint++];  //J[̓ǂݎ̑I8
				int mask = 0x80;
				for(int j=0;j<8;j++){
					if((flag & mask) != 0){
						//At@ǂݎ
						alpha[imgPoint++] = (src[srcPoint++]&0xFF) << 24;
					}else{
						int loop = (src[srcPoint++] & 0xFF) + 2; //JԂ̉񐔁A256܂
						int paltPoint = (imgPoint - (src[srcPoint++] & 0xFF) -1); //Õpbg̎QƊJnʒu
						for(int i=0;i<loop;i++){
							alpha[imgPoint++] = alpha[paltPoint++]; //Rs[
						}
					}
					mask = mask >> 1;
				}
			}
		}catch(ArrayIndexOutOfBoundsException e){}
		//At@`lݒ肵܂
		int len = width*height;
		for(int i=0;i<len;i++){
			pixel[i] = (pixel[i] & 0x00FFFFFF) | alpha[i];
		}
	}
	/**
	* 1byte傫ق8booleanɂ܂B
	*/
	private boolean[] byteToBoolean(byte b){
		boolean[] flag = new boolean[8];
		int mask = 0x80;
		for(int i=0;i<8;i++){
			flag[i] = ((b & mask) != 0);
			mask = mask >> 1;
		}
		return flag;
	}
}
