/*
 * @(#)PNGReader.java	1.01 01/04/21
 *
 * Copyright 2000-2001 icPF
 * 
 */
 package yoshi.imageio.reader;
 
//import java.awt.image.BufferedImage;
import java.awt.image.*;
import java.io.*;
import java.util.zip.*;
import java.util.Vector;
import java.util.Enumeration;

public class PNGReader extends ImageReader
{
	//static
	//PNG`Header
	static final byte[] pngHeader 
		= {(byte)0x89,(byte)0x50,(byte)0x4E,(byte)0x47,(byte)0x0D,(byte)0x0A,(byte)0x1A,(byte)0x0A};
	
	//tB^[
	static final int PNG_FILTER_NONE = 0;
	static final int PNG_FILTER_SUB = 1;
	static final int PNG_FILTER_UP = 2;
	static final int PNG_FILTER_AVERAGE = 3;
	static final int PNG_FILTER_PAETH = 4;
	
	//RXgN^
	/**
	* PNGw肵ăNX܂
	* @param in ǂ݂PNGt@C
	*/
	public PNGReader(InputStream in){
		readData(in);
	}
	/**
	* 摜o܂
	* @return inplantPNG̊Ỏ摜
	* @exception IOException Xg[̃G[
	*/
	public BufferedImage getImage(){
		return img;
	}
	public int getColorType(){
		return color_type;
	}
	public int getInterlace(){
		return interlace_method;
	}
	protected boolean readOther(InputStream in,String name,int size){
		try{
			in.skip(size+4);
		}catch(IOException e){
			return false;
		}
		return true;
	}
	protected boolean readOther(InputStream in,int name,int size){
		try{
			in.skip(size+4);
		}catch(IOException e){
			return false;
		}
		return true;
	}
	/**
	* byte[4]zintegerɂ܂
	* @param b oCgz
	* @param st Jnʒu
	* @return ǂݎinteger
	*/
	protected int byteToInt(byte[] b,int st){
		return ((b[st]&0xFF) << 24)
				| ((b[st+1]&0xFF) << 16)
				| ((b[st+2]&0xFF) << 8)
				| ( b[st+3]&0xFF);
	}
	
	//ȉprivate
    
	//IHDR
	private int width;//摜̕
	private int height;//摜̍
	private int bit_depth;//F
	private int color_type;//J[^Cv
	private int compression_method;//k
	private int filter_method;//tB^
	private int interlace_method;//C^[X
	
	private boolean useAlpha;
	private boolean usePalette;
	private boolean useColor;
	
	//tB^[p
	private int lineWidth;
	private int bpp;
	
	//pbgp
	private int[] pletRGB;

	private BufferedImage img;
	
	/**
	* PNG̉͂n߂܂B
	*/
	private void readData(InputStream in){
		checkRead(in);
		try{
			in.close();
		}catch(IOException e){
		}
	}
	private void checkRead(InputStream in){
		//wb_[ǂ݂܂
		byte[] buff = new byte[8];
		try{
			in.read(buff);
		}catch(IOException e){
			return;
		}
		for(int i=0;i<8;i++){
			if(buff[i] != pngHeader[i]){
				return;
			}
		}
		
		Vector compList = new Vector();
		boolean flag = true;
		
		//`Nǂ݂܂
		while(flag){
			try{
				in.read(buff);
			}catch(IOException e){
				return;
			}
			int size = byteToInt(buff,0);
			String strChunk = new String(buff,4,4);
			if(strChunk.equals("IHDR")){
				flag = readIHDR(in,size);
			}else if(strChunk.equals("IDAT")){
				flag = readIDAT(in,size,compList);
			}else if(strChunk.equals("IEND")){
				//readIEND();
				break;
			}else if(strChunk.equals("PLTE")){
				flag = readPLTE(in,size);
			}else if(strChunk.equals("tRNS")){
				flag = readTRNS(in,size);
			}else{
				flag = readOther(in,strChunk,size);
			}
		}
		if(!flag){
			System.out.println("G[");
			return;
		}
		//`N͏I
		//bpp̐ݒ
		setConst();
		//
		Enumeration e = compList.elements();
		InputStream is = new SequenceInputStream(e);
		is = new InflaterInputStream(is, new Inflater());
		is = new BufferedInputStream(is,lineWidth);  //ꂪȂƃf[^ςɂȂ܂
		
		//쐬
		createIDAT(is);
	}
	/**
	* wb_[ǂݎ܂
	*/
	private boolean readIHDR(InputStream in,int size){
		//ǂݍ݊Jn
		byte[] buff = new byte[13+4];
		try{
			in.read(buff);
		}catch(IOException e){
			return false;
		}
		//CRC`FbN
		CRC32 crc = new CRC32();
		crc.update("IHDR".getBytes());
		crc.update(buff,0,13);
		if(byteToInt(buff,13) != (int)crc.getValue()){
			System.out.println("CRCG[");
			return false;
		}
		
		//f[^
		width = byteToInt(buff,0);
		height = byteToInt(buff,4);
		bit_depth = buff[8];
		
		if(bit_depth != 8){
			return false;
		}
		
		color_type = buff[9];
		compression_method = buff[10];
		filter_method = buff[11];
		interlace_method = buff[12];
		
		//color_type
		// 0000 0001 CfbNXJ[̎gp
		usePalette = ((color_type & 0x01) != 0);
		// 0000 0010 tJ[A(0̏ꍇOCXP[)
		useColor = ((color_type  & 0x02) != 0);
		// 0000 0100 At@`l̎gp
		useAlpha = ((color_type & 0x04) != 0);
		
		return true;
	}
	/**
	* Iȑ傫̓ǂݎłBT|[gĂ܂B
	*/
/*	private void readPHYS(int n) throws IOException{
		//ǂݍ݊Jn
		CRC32 crc = new CRC32();
		crc.update("pHYs".getBytes());
		byte[] buff = new byte[n];
		in.read(buff);
		crc.update(buff);
		if(readInt()!=(int)crc.getValue()){
			throw new IOException("CRC Errer");
		}
		return;
	}*/
	/**
	* kf[^ǂݎ܂
	*/
	private boolean readIDAT(InputStream in,int compLen,Vector compList){
		//ǂݍ݊Jn
		byte[] imageBuff = new byte[compLen];
		byte[] crcBuff = new byte[4];
		try{
			in.read(imageBuff);
			in.read(crcBuff);
		}catch(IOException e){
			return false;
		}
		//CRC`FbN
		CRC32 crc = new CRC32();
		crc.update("IDAT".getBytes());
		crc.update(imageBuff);
		if(byteToInt(crcBuff,0) != (int)crc.getValue()){
			System.out.println("CRCG[");
			return false;
		}
		//
		compList.add(new ByteArrayInputStream(imageBuff));
		//capacity += compLen;
		
		return true;
	}
	/**
	* pbg̓ǂݍ݂ł
	*/
	private boolean readPLTE(InputStream in,int size){
		//ǂݍ݊Jn
		byte[] buff = new byte[size+4];
		try{
			in.read(buff);
		}catch(IOException e){
			return false;
		}
		CRC32 crc = new CRC32();
		crc.update("PLTE".getBytes());
		crc.update(buff,0,size);
		if(byteToInt(buff,size) != (int)crc.getValue()){
			System.out.println("CRCG[");
			return false;
		}
		//
		int n = size/3;
		pletRGB = new int[n];
		int p = 0;
		for(int i=0;i<n;i++){
			pletRGB[i] 
				= ((buff[p++]&0xFF) << 16)
				| ((buff[p++]&0xFF) << 8)
				| ( buff[p++]&0xFF);
		}
		
		return true;
	}
	/**
	* xł
	*/
	private boolean readTRNS(InputStream in,int size){
		//ǂݍ݊Jn
		byte[] buff = new byte[size+4];
		try{
			in.read(buff);
		}catch(IOException e){
			return false;
		}
		CRC32 crc = new CRC32();
		crc.update("tRNS".getBytes());
		crc.update(buff,0,size);
		if(byteToInt(buff,size) != (int)crc.getValue()){
			System.out.println("CRCG[");
			return false;
		}
		
		//
		for(int i=0;i<size;i++){
			pletRGB[i] = ((buff[i]&0xFF) << 24) | (pletRGB[i] & 0x00FFFFFF);
		}
		
		return true;
	}
	/**
	* PNG̏I܂
	*/
/*	private void readIEND() throws IOException{
		CRC32 crc = new CRC32();
		crc.update("IEND".getBytes());
		if(readInt()!=(int)crc.getValue()){
			throw new IOException("CRC Errer");
		}
		return;
	}*/
	
	/**
	* f[^͂ł̕KvȐݒ܂B
	*/
	private void setConst(){
		if(usePalette){
			bpp = 1;
		}else{
			if(useColor){
				bpp = 3;
			}else{
				bpp = 1;
			}
			if(useAlpha){
				bpp++;
			}
		}
		lineWidth = bpp*width;
	}

	/**
	* Lf[^̉͂ł
	*/
	private void createIDAT(InputStream in){
		byte[] buffPixel;
		//DIB`̃oCgɂ܂B
		if(interlace_method==1){
			buffPixel = normalizeInterlace(in);
		}else{
			buffPixel = normalize(in);
		}
		try{
			in.close();
		}catch(IOException e){}
		
		if(buffPixel == null){
			return;
		}
		//int[] pixel = null;
		if(usePalette){
			setPixelPlet(buffPixel);
		}else{
			if(useColor){
				setPixelNormal(buffPixel);
			}else{
				setPixelGray(buffPixel);
			}
		}
		buffPixel = null;
		//img = createBufferedImage(pixel,width,height,useAlpha);
	}
	private byte[] normalizeInterlace(InputStream in){
		byte[] buffPixel = new byte[lineWidth*height];
		int[] startX = {0,4,0,2,0,1,0};
		int[] startY = {0,0,4,0,2,0,1};
		int[] stepX	 = {8,8,4,4,2,2,1};
		int[] stepY	 = {8,8,8,4,4,2,2};
		int widthTemp = width;
		int heightTemp = height;
		int n = 0;
		int size = 0;
		
		for(int k=0;k<7;k++){
			//摜̃TCY߂
			width = (widthTemp+stepX[k]-1-startX[k])/stepX[k];
			height = (heightTemp+stepY[k]-1-startY[k])/stepY[k];
			lineWidth = bpp*width;
			byte[] temp = normalize(in);
			//ȉ摜̍쐬
			int p = 0;
			for(int j=startY[k];j<heightTemp;j+=stepY[k]){
				int jw = j*widthTemp*bpp;
				for(int i=startX[k]*bpp;i<widthTemp*bpp;i+=stepX[k]*bpp){
					for(int m=0;m<bpp;m++){
						buffPixel[i+jw+m] = temp[p+m];
					}
					p += bpp;
				}
			}
		}
		width = widthTemp;
		height = heightTemp;
		
		return buffPixel;
	}
	
	private byte[] normalize(InputStream in){
		byte[] buffPixel = new byte[lineWidth*height];

		byte[] raw = new byte[lineWidth];
		byte[] prior = new byte[lineWidth];
		byte[] swap;

		int pixelPoint = 0;
		int filter;
		
		for(int j=0;j<height;j++){
			//O̍s̕ۑ
			swap = prior;
			prior = raw;
			raw = swap;
			//ǂݍ
			try{
				filter = in.read();
				in.read(raw);
			}catch(IOException e){
				return null;
			}
			
			//tB^O
			switch(filter){
				case PNG_FILTER_NONE:
					break;
				case PNG_FILTER_SUB:
					antiSub(raw);
					break;
				case PNG_FILTER_UP:
					antiUp(raw,prior);
					break;
				case PNG_FILTER_AVERAGE:
					antiAverage(raw,prior);
					break;
				case PNG_FILTER_PAETH:
					antiPaeth(raw,prior);
					break;
			}
			//tB^Õf[^̏
			System.arraycopy(raw,0,buffPixel,pixelPoint,lineWidth);
			pixelPoint += lineWidth;
		}
		
		raw = null;
		prior = null;
		
		return buffPixel;
	}
	
	private void setPixelPlet(byte[] buffPixel){
		int wh = width*height;
		int[] pixel = new int[wh];
		for(int i=0;i<wh;i++){
			pixel[i] = pletRGB[buffPixel[i]&0xFF];
		}
		img = createBufferedImage(pixel,width,height,useAlpha);
	}

	private void setPixelNormal(byte[] buffPixel){
		int wh = width*height;
		int[] pixel = new int[wh];
		int p = 0;
		
		if(useAlpha){
			for(int i=0;i<wh;i++){
				pixel[i] = ((buffPixel[p++]&0xFF) << 16)
					| ((buffPixel[p++]&0xFF) << 8)
					| (buffPixel[p++]&0xFF)
					| ((buffPixel[p++]&0xFF) << 24);
			}
			img = createBufferedImage(pixel,width,height,useAlpha);
		}else{
			for(int i=0;i<wh;i++){
				pixel[i] = ((buffPixel[p++]&0xFF) << 16)
					| ((buffPixel[p++]&0xFF) << 8)
					| (buffPixel[p++]&0xFF);
			}
			//SampleModel model = new MultiPixelPackedSampleModel(DataBuffer.TYPE_BYTE,width,height,24,3*width,0);
			//WritableRaster wr = Raster.createWritableRaster(model,new DataBufferByte(buffPixel),
		}
		img = createBufferedImage(pixel,width,height,useAlpha);
	}
	private void setPixelGray(byte[] buffPixel){
		int wh = width*height;
		int[] pixel = new int[wh];
		
		if(useAlpha){
			int p = 0;
			for(int i=0;i<wh;i++){
				int b = buffPixel[p++]&0xFF;
				pixel[i] = (b << 16) | (b << 8) | b
					| ((buffPixel[p++]&0xFF) << 24);
			}
		}else{
			for(int i=0;i<wh;i++){
				int b = buffPixel[i]&0xFF;
				pixel[i] = (b << 16) | (b << 8) | b;
			}
		}
		img = createBufferedImage(pixel,width,height,useAlpha);
	}
	/**
	* SubtB^[
	*/
	private void antiSub(byte[] bRaw){
		for(int j=bpp;j<lineWidth;j++){
			bRaw[j] = (byte)(bRaw[j] + bRaw[j-bpp]);
		}
	}
	/**
	* UptB^[
	*/
	private void antiUp(byte[] bRaw, byte[] bPrior){
		for(int j=0;j<lineWidth;j++){
			bRaw[j] = (byte)(bRaw[j] + bPrior[j]);
		}
	}
	/**
	* AveragetB^[
	*/
	private void antiAverage(byte[] bRaw, byte[] bPrior){
		for(int j=0;j<bpp;j++){
			bRaw[j] = (byte)( (bRaw[j]&0xFF) + (bPrior[j]&0xFF)/2 );
		}
		for(int j=bpp;j<lineWidth;j++){
			bRaw[j] = (byte)( (bRaw[j]&0xFF) + ((bRaw[j-bpp]&0xFF)+(bPrior[j]&0xFF))/2 );
		}
	}
	/**
	* PaethtB^[
	*/
	private void antiPaeth(byte[] bRaw, byte[] bPrior){
		for(int j=0;j<bpp;j++){
			bRaw[j] = (byte)( (bRaw[j]&0xFF) + paethPredictor(0,bPrior[j]&0xFF,0) );
		}
		for(int j=bpp;j<lineWidth;j++){
			bRaw[j] = (byte)( (bRaw[j]&0xFF) + paethPredictor(bRaw[j-bpp]&0xFF,bPrior[j]&0xFF,bPrior[j-bpp]&0xFF) );
		}
	/*	int raw, priorPixel, priorRow, priorRowPixel;
		for (int i = 0; i < bpp; i++) {
			raw = bRaw[i] & 0xff;
			priorRow = bPrior[i] & 0xff;
			bRaw[i] = (byte)(raw + priorRow);
		}
		for (int i = bpp; i < lineWidth; i++) {
			raw = bRaw[i] & 0xff;
			priorPixel = bRaw[i - bpp] & 0xff;
			priorRow = bPrior[i] & 0xff;
			priorRowPixel = bPrior[i - bpp] & 0xff;

			bRaw[i] = (byte)(raw + paethPredictor(priorPixel,priorRow,priorRowPixel));
		}*/
	}
	/**
	* PaethASY
	*/
	private int paethPredictor(int a,int b,int c){
		//a = left, b = above, c = upper left
		int p = a + b - c;	//initial estimate
		int pa = abs(p - a);  //distances to a, b, c
		int pb = abs(p - b);
		int pc = abs(p - c);
		if((pa <= pb) && (pa <= pc)){
			return a;
		}else if(pb <= pc){
			return b;
		}else{
			return c;
		}
	}
	private int abs(int x){
		return (x < 0) ? -x : x;
	}
}
