//Written by JavaMaker
//BMPReader.java
package yoshi.imageio.writer;

import java.io.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.util.*;

public class BMPWriter
{
	public static final int FULLCOLOR = 24;
	public static final int INDEX256 = 8;
	public static final int INDEX16 = 4;
	public static final int INDEX2 = 1;
	
	/**
	* 摜VKɐݒ肵܂B
	*/
	public boolean setImage(BufferedImage img){
		width = img.getWidth();
		height = img.getHeight();
		if(width <= 0 || height <= 0){
			return false;
		}
		pixel = new int[width*height];
		img.getRGB(0,0,width,height,pixel,0,width);
		//f[^쐬
		indexColorNumber = checkPlet();
		
		return true;
	}
	private int checkPlet(){
		HashSet count = new HashSet();
		int n = pixel.length;
		for(int i=0;i<n;i++){
			count.add(new Integer(pixel[i]));
			if(count.size() > 256) return Integer.MAX_VALUE;
		}
		int len = count.size();
		pletBuff = new int[len];
		Object[] temp = count.toArray();
		for(int i=0;i<len;i++){
			pletBuff[i] = ((Integer)temp[i]).intValue();
		}
		return len;
	}
	
	public int getColorNumber(){
		return indexColorNumber;
	}
	public void write(OutputStream out) throws IOException{
		if(pixel == null) throw new IOException("Image is null");
		
		checkWrite(out);
		pixel = null;
		pletBuff = null;
		
		//Ȃdlɂ܂
		/*try{
			out.close();
		}catch(IOException e){}
		*/
	}
	/**
	* BMPp
	*/
	public void setBitSize(int bitSize){
		this.bitSize = bitSize;
	}
	private int[] pixel;
	private int[] pletBuff = null;
	private int width,height;
	private int bitSize = 24;
	private int indexColorNumber;
	
	private void checkWrite(OutputStream out){
		//f[^쐬
		changeBitSize(indexColorNumber);
		byte[] imgBuff = makeBuff();
		//
		try{
			if(pletBuff != null){
				writeHeader(out,pletBuff.length,imgBuff.length);
			}else{
				writeHeader(out,0,imgBuff.length);
			}
			writePlet(out);
			out.write(imgBuff);
		}catch(IOException e){
			System.out.println(e);
		}
	}
	
	private void changeBitSize(int len){
		switch(bitSize){
			case 1:
				if(len <= 2){
					break;
				}else{
					bitSize = 4;
				}
			case 4:
				if(len <= 16){
					break;
				}else{
					bitSize = 8;
				}
			case 8:
				if(len <= 256){
					break;
				}else{
					bitSize = 24;
				}
			case 24:
				pletBuff = new int[0];
				break;
			default:
				return;
		}
	}
	private void writeHeader(OutputStream out,int pletSize,int imgSize) throws IOException{
		//54byte 0x36
		writeShort(out,19778);  //BM
		writeInt(out,54+pletSize*4+imgSize); //t@CTCY
		writeInt(out,0);  //\ 4byte
		writeInt(out,54+pletSize*4); //摜f[^̃ItZbg
		writeInt(out,40); //ubN̒
		writeInt(out,width); //摜̕
		writeInt(out,height); //摜̍
		writeShort(out,1); //v[̃TCY
		writeShort(out,bitSize); //PsNZ̃f[^
		writeInt(out,0);  //摜̈k
		if(bitSize==24){
			writeInt(out,width*height); //摜TCY
		}else{
			writeInt(out,0); //摜TCY
		}
		writeInt(out,0);  //ۂ̑傫igĂȂj
		writeInt(out,0);
		if(bitSize == 8){
			writeInt(out,pletBuff.length); //pbg
		}else{
			writeInt(out,0);
		}
		writeInt(out,0); //dvȃpbg̃CfbNX
	}
	private void writePlet(OutputStream out) throws IOException{
		if(bitSize != 24){
			int len = pletBuff.length*4;
			if(bitSize == 1 && len != 8){
				len = 8;
			}else if(bitSize == 4 && len != 64){
				len = 64;
			}
			byte[] buff = new byte[len];
			int bp = 0;
			for(int i=0;i<pletBuff.length;i++){
				int p = pletBuff[i];
				buff[bp++] = (byte)p;
				buff[bp++] = (byte)(p >> 8);
				buff[bp++] = (byte)(p >> 16);
				buff[bp++] = 0;
			}
			out.write(buff);
		}
	}
	private byte[] makeBuff(){
		switch(bitSize){
		case 24:
			return makeFullColor();
		case 8:
			return make256Color();
		case 4:
			return make16Color();
		case 1:
			return make2Color();
		}
		return null;
	}
	private byte[] makeFullColor(){
		int lineWidth = normalizeMod(3*width,4);
		byte[] imgBuff = new byte[lineWidth*height];
		int rest = lineWidth - 3*width;
		int ip = 0;
		int offset = height*width;
		
		for(int j = height-1;j>=0;j--){
			offset -= width;
			for(int i=0;i<width;i++){
				int p = pixel[offset+i];
				imgBuff[ip++] = (byte)p;
				imgBuff[ip++] = (byte)(p >> 8);
				imgBuff[ip++] = (byte)(p >> 16);
			}
			ip += rest;
		}
		
		return imgBuff;
	}
	private byte[] make256Color(){
		HashMap plet = new HashMap();
		int len = pletBuff.length;
		for(int i=0;i<len;i++){
			plet.put(new Integer(pletBuff[i]),new Integer(i));
		}
		int lineWidth = normalizeMod(width,4);
		byte[] imgBuff = new byte[lineWidth*height];
		int rest = lineWidth - width;
		int ip = 0;
		int offset = height*width;
		
		for(int j = height-1;j>=0;j--){
			offset -= width;
			for(int i=0;i<width;i++){
				Integer temp = (Integer)plet.get(new Integer(pixel[offset+i]));
				imgBuff[ip++] = (byte)(temp.intValue());
			}
		}
		
		return imgBuff;
	}
	private byte[] make16Color(){
		TreeMap plet = new TreeMap();
		int len = pletBuff.length;
		for(int i=0;i<len;i++){
			plet.put(new Integer(pletBuff[i]),new Integer(i));
		}
		int lineWidth = normalizeMod((width+1)/2,4);
		byte[] imgBuff = new byte[lineWidth*height];
		int rest = lineWidth - (width+1)/2;
		int ip = 0;
		int offset = height*width;
		
		for(int j = height-1;j>=0;j--){
			offset = j*width;
			for(int i=0;i<width/2;i++){
				Integer temp1 = (Integer)plet.get(new Integer(pixel[offset++]));
				Integer temp2 = (Integer)plet.get(new Integer(pixel[offset++]));
				imgBuff[ip++] = (byte)(((temp1.intValue() << 4) & 0xF0) + (temp2.intValue() & 0x0F));
			}
			if(width%2 == 1){
				Integer temp1 = (Integer)plet.get(new Integer(pixel[offset++]));
				imgBuff[ip] = (byte)((temp1.intValue() << 4) & 0xF0);
				ip++;
			}
			ip += rest;
		}
		return imgBuff;
	}
	private byte[] make2Color(){
		byte[] imgBuff = new byte[normalizeMod((width+7)/8,4)*height];
		int step = normalizeMod((width+7)/8,4) - (width+7)/8;
		int ip = 0;
		int offSet = height*width;
		
		for(int j = height-1;j>=0;j--){
			offSet -= width;
			int p = offSet;
			for(int i=0;i<width/8;i++){
				boolean[] flag = new boolean[8];
				for(int k=0;k<8;k++){
					flag[k] = (pletBuff[0] != pixel[p]);
					p++;
				}
				imgBuff[ip] = booleanToByte(flag);
				ip++;
			}
			
			if(width%8 != 0){
				boolean[] flag = new boolean[8];
				for(int k=0;k<8;k++){
					if(k >= width%8) break;
					flag[k] = (pletBuff[0] != pixel[p]);
					p++;
				}
				imgBuff[ip] = booleanToByte(flag);
				ip++;
			}
			ip += step;
		}
		
		return imgBuff;
	}
	private byte booleanToByte(boolean[] flag){
		int mask = 0x80;
		int b = 0;
		for(int i=0;i<8;i++){
			if(flag[i]){
				b += mask;
			}
			mask = mask >> 1;
		}
		return (byte)b;
	}
	private int normalizeMod(int n,int m){
		return (n + m -1)/m*m;
	}
	private void writeShort(OutputStream out,int n) throws IOException{
		byte[] buff = new byte[2];
		buff[1] = (byte)(n >> 8);
		buff[0] = (byte)n;
		out.write(buff);
	}
	private void writeInt(OutputStream out,int n) throws IOException{
		byte[] buff = new byte[4];
		buff[3] = (byte)(n >> 24);
		buff[2] = (byte)(n >> 16);
		buff[1] = (byte)(n >>  8);
		buff[0] = (byte)n;
		out.write(buff);
	}
}
