/*
 * @(#)PNGWriter.java	1.01 01/04/21
 *
 * Copyright 2000-2001 icPF
 * 
 */
package yoshi.imageio.writer;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.*;
import java.util.zip.*;
import java.util.*;
//import javax.swing.JProgressBar;
/**
 * PNGOutputStreamPNGނ߂̃NXłB<br>
 * PNG摜`Ƃ<br>
 * W̃wb_ƃ`N(chunk)ƌĂ΂ubNłĂ܂B<br>
 * `N̍\AۑĂf[^̃oCg{SȂ鎯ʎq{f[^{́{CRC(SoCg)<br>
 * `N̗@IDHRAwb_@AL^Ă܂B<br>
 * @author		icPF
 * @version		1.01 01/04/21
 * @since		JDK1.3
 */

public class PNGWriter
{
	//TODO: ̈ʒuɕϐ̐錾Ă
	public static final int FILTER_NONE = 0;
	public static final int FILTER_SUB_ONLY = 1;
	public static final int FILTER_UP_ONLY = 2;
	public static final int FILTER_AVERAGE_ONLY = 3;
	public static final int FILTER_PAETH_ONLY = 4;
	public static final int FILTER_ABS_SUM_MIN = 5;

	/**
	* 摜VKɐݒ肵܂B
	*/
	public boolean setImage(BufferedImage img){
		width = img.getWidth();
		height = img.getHeight();
		if(width <= 0 || height <= 0){
			return false;
		}
		pixel = new int[width*height];
		img.getRGB(0,0,width,height,pixel,0,width);
		//f[^쐬
		indexColorNumber = checkPlet();
		
		return true;
	}
	/**
	* CfbNXJ[̍쐬
	*/
	private int checkPlet(){
		int n = pixel.length;
		HashSet count = new HashSet();
		int last = pixel[0];
		count.add(new Integer(pixel[0]));
		
		for(int i=1;i<n;i++){
			if(last != pixel[i]){
				last = pixel[i];
				count.add(new Integer(pixel[i]));
				if(count.size() > 256) return Integer.MAX_VALUE;
			}
		}
		int len = count.size();
		pletBuff = new int[len];
		Iterator iterator = count.iterator();
		//Object[] obj = count.toArray();
		for(int i=0;i<len;i++){
			pletBuff[i] = ((Integer)iterator.next()).intValue();
			//pletBuff[i] = ((Integer)obj[i]).intValue();
		}
		return len;
		
		/*IntVector vec = new IntVector(pixel[0]);
		for(int i=1;i<pixel.length;i++){
			vec.add(pixel[i]);
			if(vec.size() > 256) return Integer.MAX_VALUE;
		}
		pletBuff = vec.toArray();
		return pletBuff.length;*/
	}
	public void write(OutputStream out) throws IOException{
		if(pixel == null) throw new IOException("Image is null");
		
		//long st = System.currentTimeMillis();
		makeBuff();
		//long st = System.currentTimeMillis();
		Deflater deflater = new Deflater(compLevel);
		deflater.setInput(buffPixel);
		deflater.finish();
		//buffPixel = null;
		byte[] compBuff = new byte[(lineWidth+1)*height];
		int len = deflater.deflate(compBuff);
		//long et = System.currentTimeMillis();
		//System.out.println("deflate "+(et-st));
		
		//st = System.currentTimeMillis();
		/*write Header*/
		out.write(pngHeader);
		/*write data*/
		writeIHDR(out);
		//writePHYS(out);
		//writeOther(out);
		if(usePalette){
			writePLTE(out);
			if(useAlpha){
				writeTRNS(out);
			}
		}
		writeIDAT(out,compBuff,len);
		//writeTIME(out);
		writeIEND(out);
		//et = System.currentTimeMillis();
		//System.out.println("write to OutputStream "+(et-st));
		
		pixel = null;
		pletBuff = null;
		buffPixel = null;
		
		//Ȃdlɂ܂
		/*try{
			out.close();
		}catch(IOException e){}
		*/
	}
	/**
	* FԂ܂B
	*/
	public int getColorNumber(){
		return indexColorNumber;
	}
	/**
	* tB^[IASYI܂
	* @param filterLevel ASY̑I
	*/
	public void setFilterLevel(int filterLevel){
		this.filterLevel = Math.min(6,Math.max(0,filterLevel));
	}
	/**
	* zip̈kx߂܂
	* 1-9܂ł܂łT|[gĂ܂B
	*/
	public void setCompressionLevel(int compLevel){
		this.compLevel = Math.min(9,Math.max(1,compLevel));
	}
	/**
	* At@lAxgp܂B
	*/
	public void setUseAlpha(boolean useAlpha){
		this.useAlpha = useAlpha;
	}
	/**
	* O[XP[ɂ܂B
	*/
	public void setUseGray(boolean useGray){
		this.useColor = !useGray;
		if(!useColor){
			usePalette = false;
		}
	}
	/**
	* pbggp܂
	*/
	public void setUsePalette(boolean usePalette){
		this.usePalette = usePalette;
		if(usePalette){
			useColor = true;
		}
	}
	
	/**
	* adam7C^[[Xgp܂
	*/
	public void setUseInterlace(boolean interlace){
		if(interlace){
			this.interlace_method = 1;
		}else{
			this.interlace_method = 0;
		}
	}

	//ȉprotected
	/**
	* I[o[Ch邱ƂɂĐV`Nǉ݂܂B
	*/
	protected void writeOther(OutputStream out) throws IOException{
		return;
	}
	protected void writeInt(OutputStream out,int n) throws IOException{
		byte[] b = new byte[4];
		b[0] = (byte)(n >> 24);
		b[1] = (byte)(n >> 16);
		b[2] = (byte)(n >>  8);
		b[3] = (byte)(n);
		out.write(b);
		return;
	}
	//ȉprivate
	private final byte[] pngHeader 
		= {(byte)0x89,(byte)0x50,(byte)0x4E,(byte)0x47,(byte)0x0D,(byte)0x0A,(byte)0x1A,(byte)0x0A};//PNG`Header
	
	//IHDR
	private int width;//摜̕
	private int height;//摜̍
	private int bit_depth = 8;//F8->256K
	private boolean usePalette = false;//pbg̎gp
	private boolean useColor = true;//tJ[̎gp
	private boolean useAlpha = false;//At@̎gp
	private int compression_method = 0;//k
	private int filter_method = 0;//tB^
	private int interlace_method = 0;//C^[X
	
	private int indexColorNumber;
	//IDAT
	private int[] pixel = null;//摜̃sNZ
	
	private int compLevel = Deflater.BEST_COMPRESSION;
	
	private int filterLevel = 0;//tB^[pk
	private int filterNumber = 5;
	private int lineWidth;
	private int bpp;
	
	private int[] pletBuff;
	private byte[] buffPixel;
	
	/**
	* wb_[݂܂
	*/
	private void writeIHDR(OutputStream out) throws IOException{
		//ݏ
		byte[] b = new byte[13];
		b[0] = (byte)(width >> 24);
		b[1] = (byte)(width >> 16);
		b[2] = (byte)(width >>  8);
		b[3] = (byte)(width);
		b[4] = (byte)(height >> 24);
		b[5] = (byte)(height >> 16);
		b[6] = (byte)(height >>  8);
		b[7] = (byte)(height);
		b[8] = (byte)bit_depth;
		b[9] = (byte)colorType();
		b[10] = (byte)compression_method;
		b[11] = (byte)filter_method;
		b[12] = (byte)interlace_method;
		
		byte[] name = "IHDR".getBytes();
		CRC32 crc = new CRC32();
		//݊Jn
		writeInt(out,13);
		out.write(name);
		crc.update(name);
		out.write(b);
		crc.update(b);
		writeInt(out,(int)crc.getValue());
	}
	/**
	* ݂̃J[^Cv𓾂܂
	*/
	private int colorType(){
		int c = 0;
		if(usePalette) c += 1;
		if(useColor) c += 2;
		if(!usePalette && useAlpha) c += 4;
		return c;
	}
	/**
	* ITCY݂܂
	*/
/*	private void writePHYS(OutputStream out) throws IOException{
		//ݏ
		byte[] b = {(byte)0x00,(byte)0x00,(byte)0x0E,(byte)0xC4,(byte)0x00,(byte)0x00,(byte)0x0E,(byte)0xC4,(byte)0x00};
		CRC32 crc = new CRC32();
		//݊Jn
		writeInt(9);
		out.write("pHYs".getBytes());
		crc.update("pHYs".getBytes());
		out.write(b);
		crc.update(b);
		writeInt((int)crc.getValue());
		return;
	}*/
	/**
	* CfbNXJ[݂܂
	*/
	private void writePLTE(OutputStream out) throws IOException{
		//ݏ
		int len = pletBuff.length;
		byte[] b = new byte[3*len];
		int i3 = 0;
		for(int i=0;i<len;i++){
			int p = pletBuff[i];
			b[i3++] = (byte)(p >> 16);
			b[i3++] = (byte)(p >> 8);
			b[i3++] = (byte)p;
		}
		byte[] name = "PLTE".getBytes();
		CRC32 crc = new CRC32();
		//݊Jn
		writeInt(out,3*len);
		out.write(name);
		crc.update(name);
		out.write(b);
		crc.update(b);
		writeInt(out,(int)crc.getValue());
	}
	/**
	* x݂܂
	*/
	private void writeTRNS(OutputStream out) throws IOException{
		//ݏ
		int len = pletBuff.length;
		byte[] b = new byte[len];
		for(int i=0;i<len;i++){
			b[i] = (byte)(pletBuff[i] >> 24);
		}
		byte[] name = "tRNS".getBytes();
		CRC32 crc = new CRC32();
		//݊Jn
		writeInt(out,len);
		out.write(name);
		crc.update(name);
		out.write(b);
		crc.update(b);
		writeInt(out,(int)crc.getValue());
		
		pletBuff = null;
	}
	/**
	* C[Wf[^݂܂
	*/
	private void writeIDAT(OutputStream out,byte[] compBuff,int len) throws IOException{
		//ݏ
		//int len = deflater.deflate(buffPixel);
		byte[] name = "IDAT".getBytes();
		CRC32 crc = new CRC32();
		//݊Jn
		writeInt(out,len);
		out.write(name);
		crc.update(name);
		out.write(compBuff,0,len);
		//out.write(buffPixel,0,len);
		crc.update(compBuff,0,len);
		//crc.update(buffPixel,0,len);
		writeInt(out,(int)crc.getValue());
	}
	/**
	* XVԂ݂܂
	*/
	private void writeTIME(OutputStream out) throws IOException{
		//ݏ
		byte[] b = new byte[7];
		Calendar now = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
		int year = now.get(Calendar.YEAR);
		b[0] = (byte)((year >> 8) & 0x00FF);
		b[1] = (byte)(year & 0x00FF);
		b[2] = (byte)(now.get(Calendar.MONTH)+(1-Calendar.JANUARY));
		b[3] = (byte)(now.get(Calendar.DATE));
		b[4] = (byte)(now.get(Calendar.HOUR_OF_DAY)-1);
		b[5] = (byte)(now.get(Calendar.MINUTE)-1);
		b[6] = (byte)(now.get(Calendar.SECOND)-1);
		
		byte[] name = "tIME".getBytes();
		CRC32 crc = new CRC32();
		//݊Jn
		writeInt(out,7);
		out.write(name);
		crc.update(name);
		out.write(b);
		crc.update(b);
		writeInt(out,(int)crc.getValue());
	}
	/**
	* PNG̏IӖ`N݂܂
	*/
	private void writeIEND(OutputStream out) throws IOException{
		//ݏ
		byte[] name = "IEND".getBytes();
		CRC32 crc = new CRC32();
		//݊Jn
		writeInt(out,0);
		out.write(name);
		crc.update(name);
		writeInt(out,(int)crc.getValue());
	}
	/**
	* 摜w肵`ɕϊ܂
	*/
	private void makeBuff(){
		byte[] buff;
		if(usePalette){
			if(indexColorNumber <= 256){
				//CfbNXJ[̌`
				buff = setPixelPlet();
			}else{
				//256Fȏ゠Ƃ̗O
				buff = setPixelNormal();
			}
		}else{
			if(useColor){
				//24bitJ[̌`ɂ
				buff = setPixelNormal();
			}else{
				//O[XP[̌`ɂ
				buff = setPixelGray();
			}
		}
	//	pixel = null;
		if(interlace_method == 0){
			//C^[[XłȂƂ
			switch(filterLevel){ //tB^OASY
			case FILTER_NONE:
				buffPixel = filterNone(buff);
				break;
			case FILTER_SUB_ONLY:
				buffPixel = filterSubOnly(buff);
				break;
			case FILTER_UP_ONLY:
				buffPixel = filterUpOnly(buff);
				break;
			case FILTER_AVERAGE_ONLY:
				buffPixel = filterAverageOnly(buff);
				break;
			case FILTER_PAETH_ONLY:
				buffPixel = filterPaethOnly(buff);
				break;
			case FILTER_ABS_SUM_MIN:
				buffPixel = filterAbsSumMin(buff);
				break;
			}
		}else{
			//C^[[X̂ƂAV̉摜Ƃčl
			int[] startX = {0,4,0,2,0,1,0};
			int[] startY = {0,0,4,0,2,0,1};
			int[] stepX	 = {8,8,4,4,2,2,1};
			int[] stepY	 = {8,8,8,4,4,2,2};
			int widthTemp = width;
			int heightTemp = height;
			byte[][] imgBuff = new byte[7][];
			int capacity = 0;
			
			for(int k=0;k<7;k++){
				//摜̃TCY߂
				width = (widthTemp+stepX[k]-1-startX[k])/stepX[k];
				height = (heightTemp+stepY[k]-1-startY[k])/stepY[k];
				lineWidth = bpp*width;
				byte[] temp = new byte[lineWidth*height];
				int n = 0;
				//ȉ摜̍쐬
				int lineWidthTemp = widthTemp*bpp;
				int jw = startY[k]*lineWidthTemp;
				int djw = stepY[k]*lineWidthTemp;
				
				for(int j=startY[k];j<heightTemp;j+=stepY[k]){
					int stepBpp = stepX[k]*bpp;
					for(int i=startX[k]*bpp;i<lineWidthTemp;i+=stepBpp){
						for(int m=0;m<bpp;m++){
							temp[n+m] = buff[i+m+jw];
						}
						n += bpp;
					}
					jw += djw;
				}
				switch(filterLevel){ //tB^OASY
					case FILTER_NONE: temp = filterNone(temp); break;
					case FILTER_SUB_ONLY: temp = filterSubOnly(temp); break;
					case FILTER_UP_ONLY: temp = filterUpOnly(temp); break;
					case FILTER_AVERAGE_ONLY: temp = filterAverageOnly(temp); break;
					case FILTER_PAETH_ONLY: temp = filterPaethOnly(temp); break;
					case FILTER_ABS_SUM_MIN: temp = filterAbsSumMin(temp); break;
				}
				//킹Ă
				imgBuff[k] = temp;
				capacity += temp.length;
			}
			//ɖ߂
			width = widthTemp;
			height = heightTemp;
			lineWidth = bpp*width;
			
			buffPixel = new byte[capacity];
			int pos = 0;
			for(int k=0;k<7;k++){
				System.arraycopy(imgBuff[k],0,buffPixel,pos,imgBuff[k].length);
				pos += imgBuff[k].length;
			}
		}
	}
	/**
	* CfbNXJ[ł̃C[W̔z
	*/
	private byte[] setPixelPlet(){
		bpp = 1;
		lineWidth = bpp*width;
		byte[] buff = new byte[lineWidth*height];
		TreeMap plet = new TreeMap();
		int len = pletBuff.length;
		for(int i=0;i<len;i++){
			plet.put(new Integer(pletBuff[i]),new Integer(i));
		}
		int wh = width*height;
		for(int i=0;i<wh;i++){
			Integer temp = (Integer)plet.get(new Integer(pixel[i]));
			buff[i] = (byte)(temp.intValue());
		}
		return buff;
	}
	/**
	* 24bitJ[ł̃C[W̔z
	*/
	private byte[] setPixelNormal(){
		byte[] buff;
		if(useAlpha){
			bpp = 4;
			lineWidth = bpp*width;
			buff = new byte[lineWidth*height];
			int wh = width*height;
			int n = 0;
			for(int i=0;i<wh;i++){
				int p = pixel[i];
				buff[n] = (byte)(p >> 16);
				buff[n+1] = (byte)(p >> 8);
				buff[n+2] = (byte)p;
				buff[n+3] = (byte)(p >> 24);
				n += bpp;
			}
		}else{
			bpp = 3;
			lineWidth = bpp*width;
			buff = new byte[lineWidth*height];
			int wh = width*height;
			int n = 0;
			for(int i=0;i<wh;i++){
				int p = pixel[i];
				buff[n] = (byte)(p >> 16);
				buff[n+1] = (byte)(p >> 8);
				buff[n+2] = (byte)p;
				n += bpp;
			}
		}
		return buff;
	}
	/**
	* O[XP[ł̃C[W̔z
	*/
	private byte[] setPixelGray(){
		byte[] buff;
		if(useAlpha){
			bpp = 2;
			lineWidth = bpp*width;
			buff = new byte[lineWidth*height];
			int wh = width*height;
			int n = 0;
			for(int i=0;i<wh;i++){
				int p = pixel[i];
				buff[n] = grayColor(p);
				buff[n+1] = (byte)(p >> 24);
				n += bpp;
			}
		}else{
			bpp = 1;
			lineWidth = bpp*width;
			buff = new byte[lineWidth*height];
			int wh = width*height;
			for(int i=0;i<wh;i++){
				buff[i] = grayColor(pixel[i]);
			}
		}
		return buff;
	}
	private byte grayColor(int c){
		int red = (c >> 16) & 0x00FF;
		int green = (c >> 8) & 0x00FF;
		int blue = c & 0x00FF;
		return (byte)(0.299*red+0.587*green+0.114*blue);
	}
	/**
	* ׂĂɃtB^[Ȃ(filter0){܂
	* ׂh͂̂قTCYȂ邱Ƃ܂
	*/
	private byte[] filterNone(byte[] buff){
		byte[] filtered = new byte[(lineWidth+1)*height];
		int buffPoint = 0;
		int filterPoint = 0;
		for(int j=0;j<height;j++){
			filtered[filterPoint] = (byte)0;
			filterPoint++;
			System.arraycopy(buff,buffPoint,filtered,filterPoint,lineWidth);
			buffPoint += lineWidth;
			filterPoint += lineWidth;
		}
		return filtered;
	}
	/**
	* ׂĂSubtB^[܂
	*/
	private byte[] filterSubOnly(byte[] buff){
		byte[] filtered = new byte[(lineWidth+1)*height];
		int buffPoint = 0;
		int filterPoint = 0;
		
		byte[] sub = new byte[lineWidth];
		byte[] raw = new byte[lineWidth];
		
		for(int j=0;j<height;j++){
			//ǂݍ
			System.arraycopy(buff,buffPoint,raw,0,lineWidth);
			buffPoint += lineWidth;
			//tB^[
			sub(sub,raw);
			//
			filtered[filterPoint++] = (byte)1;
			System.arraycopy(sub,0,filtered,filterPoint,lineWidth);
			filterPoint += lineWidth;
		}
		sub = null;
		raw = null;
		return filtered;
	}
	/**
	* ׂĂUptB^[܂
	*/
	private byte[] filterUpOnly(byte[] buff){
		byte[] filtered = new byte[(lineWidth+1)*height];
		int buffPoint = 0;
		int filterPoint = 0;
		
		byte[] up = new byte[lineWidth];
		byte[] raw = new byte[lineWidth];
		byte[] prior = new byte[lineWidth];
		byte[] swap;
		
		for(int j=0;j<height;j++){
			//O̍s̃Rs[
			//System.arraycopy(raw,0,prior,0,lineWidth);
			swap = prior;
			prior = raw;
			raw = swap;
			//ǂݍ
			System.arraycopy(buff,buffPoint,raw,0,lineWidth);
			buffPoint += lineWidth;
			//tB^[
			up(up,raw,prior);
			//
			filtered[filterPoint++] = (byte)2;
			System.arraycopy(up,0,filtered,filterPoint,lineWidth);
			filterPoint += lineWidth;
		}
		up = null;
		raw = null;
		prior = null;
		swap = null;
		
		return filtered;
	}
	/**
	* ׂĂAveragetB^[܂
	*/
	private byte[] filterAverageOnly(byte[] buff){
		byte[] filtered = new byte[(lineWidth+1)*height];
		int buffPoint = 0;
		int filterPoint = 0;
		
		byte[] average = new byte[lineWidth];
		byte[] raw = new byte[lineWidth];
		byte[] prior = new byte[lineWidth];
		byte[] swap;
		
		for(int j=0;j<height;j++){
			//O̍s̃Rs[
			//System.arraycopy(raw,0,prior,0,lineWidth);
			swap = prior;
			prior = raw;
			raw = swap;
			//ǂݍ
			System.arraycopy(buff,buffPoint,raw,0,lineWidth);
			buffPoint += lineWidth;
			//tB^[
			average(average,raw,prior);
			//
			filtered[filterPoint++] = (byte)3;
			System.arraycopy(average,0,filtered,filterPoint,lineWidth);
			filterPoint += lineWidth;
		}
		average = null;
		raw = null;
		prior = null;
		swap = null;
		
		return filtered;
	}

	/**
	* ׂĂPaethtB^[܂
	*/
	private byte[] filterPaethOnly(byte[] buff){
	//	return  filterNone(buff);
		
		byte[] filtered = new byte[(lineWidth+1)*height];
		int buffPoint = 0;
		int filterPoint = 0;
		
		byte[] paeth = new byte[lineWidth];
		byte[] raw = new byte[lineWidth];
		byte[] prior = new byte[lineWidth];
		byte[] swap;
		
		for(int j=1;j<height;j++){
			//O̍s̃Rs[
			//System.arraycopy(raw,0,prior,0,lineWidth);
			swap = prior;
			prior = raw;
			raw = swap;
			//ǂݍ
			System.arraycopy(buff,buffPoint,raw,0,lineWidth);
			buffPoint += lineWidth;
			//tB^[
			paeth(paeth,raw,prior);
			//
			filtered[filterPoint++] = (byte)4;
			System.arraycopy(paeth,0,filtered,filterPoint,lineWidth);
			filterPoint += lineWidth;
		}
		paeth = null;
		raw = null;
		prior = null;
		swap = null;
		return filtered;
	}
	/**
	* Βl̘a̍ŏItB^[ɂ܂
	*/
	private byte[] filterAbsSumMin(byte[] buff){
		byte[] filtered = new byte[(lineWidth+1)*height];
		int buffPoint = 0;
		int filterPoint = 0;
		
		byte[] sub = new byte[lineWidth];
		byte[] up = new byte[lineWidth];
		byte[] average = new byte[lineWidth];
		byte[] paeth = new byte[lineWidth];
		byte[] raw = new byte[lineWidth];
		byte[] prior = new byte[lineWidth];
		
		for(int j=0;j<height;j++){
			//O̍s̃Rs[
			System.arraycopy(raw,0,prior,0,lineWidth);
			//ǂݍ
			System.arraycopy(buff,buffPoint,raw,0,lineWidth);
			buffPoint += lineWidth;
			//tB^[
			long absRaw = absSum(raw);
			sub(sub,raw);
			long absSub = absSum(sub);
			up(up,raw,prior);
			long absUp = absSum(up);
			average(average,raw,prior);
			long absAve = absSum(average);
			paeth(paeth,raw,prior);
			long absPaeth = absSum(paeth);
			//tB^[̑I
			int m = getMinIndex(new long[]{absRaw,absSub,absUp,absAve,absPaeth});
			//
			switch(m){
			case 0:
				filtered[filterPoint++] = (byte)0;
				System.arraycopy(raw,0,filtered,filterPoint,lineWidth);
				break;
			case 1:
				filtered[filterPoint++] = (byte)1;
				System.arraycopy(sub,0,filtered,filterPoint,lineWidth);
				break;
			case 2:
				filtered[filterPoint++] = (byte)2;
				System.arraycopy(up,0,filtered,filterPoint,lineWidth);
				break;
			case 3:
				filtered[filterPoint++] = (byte)3;
				System.arraycopy(average,0,filtered,filterPoint,lineWidth);
				break;
			case 4:
				filtered[filterPoint++] = (byte)4;
				System.arraycopy(paeth,0,filtered,filterPoint,lineWidth);
				break;
			}
			filterPoint += lineWidth;
		}
		sub = null;
		up = null;
		average = null;
		paeth = null;
		raw = null;
		prior = null;
		
		return filtered;
	}
	/**
	* Sub Filter
	*/
	private void sub(byte[] bSub,byte[] bRaw){
		for(int j=0;j<bpp;j++){
			bSub[j] = bRaw[j];
		}
		for(int j=bpp;j<lineWidth;j++){
			bSub[j] = (byte)(bRaw[j] - bRaw[j-bpp]);
		}
	}
	/**
	* Up Filter
	*/
	private void up(byte[] bUp,byte[] bRaw,byte[] bPrior){
		for(int j=0;j<lineWidth;j++){
			bUp[j] = (byte)(bRaw[j] - bPrior[j]);
		}
	}
	/**
	* Average Filter
	*/
	private void average(byte[] bAverage,byte[] bRaw,byte[] bPrior){
		for(int j=0;j<bpp;j++){
			bAverage[j] = (byte)((bRaw[j]&0xFF) - (bPrior[j]&0xFF)/2 );
		}
		for(int j=bpp;j<lineWidth;j++){
			bAverage[j] = (byte)( (bRaw[j]&0xFF) - ((bRaw[j-bpp]&0xFF) + (bPrior[j]&0x00FF))/2 );
		}
	}
	/**
	* Paeth FIlter
	*/
	private void paeth(byte[] bPaeth,byte[] bRaw,byte[] bPrior){
		for(int j=0;j<bpp;j++){
			bPaeth[j] = (byte)((bRaw[j]&0xFF) - paethPredictor(0,bPrior[j]&0xFF,0));
		}
		for(int j=bpp;j<lineWidth;j++){
			bPaeth[j] = (byte)((bRaw[j]&0xFF) - paethPredictor(bRaw[j-bpp]&0xFF,bPrior[j]&0xFF,bPrior[j-bpp]&0xFF));
		}
	}
	private int paethPredictor(int a,int b,int c){
		//a = left, b = above, c = upper left
		int p = a + b - c;	//initial estimate
		int pa = abs(p - a);  //distances to a, b, c
		int pb = abs(p - b);
		int pc = abs(p - c);
		if(pa <= pb && pa <= pc){
			return a;
		}else if(pb <= pc){
			return b;
		}else{
			return c;
		}
	}
	private int abs(int n){
		if(n >= 0){
			return n;
		}else{
			return -n;
		}
	}
	private long absSum(byte[] filter){
		long sum = 0;
		for(int j=0;j<lineWidth;j++){
			sum += abs(filter[j]);
		}
		return sum;
	}
	private int getMinIndex(long[] n){
		long min = n[0];
		int index = 0;
		
		for(int i=1;i<n.length;i++){
			if(min >= n[i]){
				min = n[i];
				index = i;
			}
		}
		
		return index;
	}
}
