//Written by JavaMaker
//EditDialog.java
package yoshi.layer.image;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import yoshi.editmenu.*;

public class EditDialog extends JDialog
	implements ActionListener
{
	private EditPanel panel;
	private JMenuItem itemCloseOk, itemCloseCacnel;
	private ImageLayer layer;
	private Frame parent;
	
	public EditDialog(Frame parent) {
		super(parent,true);
		this.parent = parent;
		initComponents(parent);
		setLocationRelativeTo(parent);
	}
	private void initComponents(Frame parent) {
		setTitle("ҏW");
		setSize(400,300);
		
		getContentPane().setLayout(new BorderLayout());
		panel = new EditPanel(parent);
		getContentPane().add(new JScrollPane(panel), BorderLayout.CENTER);
		
		JMenuBar bar = new JMenuBar();
		bar.add(createMenuClose());
		bar.add(panel.createMenuView());
		bar.add(panel.createMenuCache());
		bar.add(panel.createMenuEdit());
		getContentPane().add(bar, BorderLayout.NORTH);
		
		setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				onItemCloseOk();
			}
		});
	}
	private JMenu createMenuClose(){
		//JMenu menu = new JMenu("(X)");
		JMenu menu = new JMenu("");
		//menu.setMnemonic('X');
		
		//itemCloseOk = new JMenuItem("ύX𔽉f(S)");
		itemCloseOk = new JMenuItem("ύX𔽉f");
		itemCloseOk.addActionListener(this);
		itemCloseOk.setToolTipText("ύX𔽉f܂BLbV͎c܂");
		//itemCloseOk.setMnemonic('S');
		menu.add(itemCloseOk);
		
		//itemCloseCacnel = new JMenuItem("ύX(D)");
		itemCloseCacnel = new JMenuItem("ύX");
		itemCloseCacnel.addActionListener(this);
		itemCloseCacnel.setToolTipText("ύX𔽉f܂BLbV͏܂");
		//itemCloseCacnel.setMnemonic('D');
		menu.add(itemCloseCacnel);
		
		return menu;
	}
	public void setImageLayer(ImageLayer layer){
		this.layer = layer;
		panel.setCache(layer.getImageCache());
	}
	public BufferedImage getImage(){
		return panel.getImage();
	}
	public void actionPerformed(ActionEvent e) {
		Object obj = e.getSource();
		if(obj == itemCloseOk){
			onItemCloseOk();
		}else if(obj == itemCloseCacnel){
			onItemCloseCacnel();
		}
		repaint();
	}
	private void onItemCloseOk(){
		int result = JOptionPane.showConfirmDialog( parent
			, "ύX𔽉fĕ܂BLbV͎c܂B낵łH"
			, "ύX̔f", JOptionPane.YES_NO_OPTION
			, JOptionPane.QUESTION_MESSAGE);
		
		if(result == JOptionPane.YES_OPTION){
			BufferedImage img = layer.getImageCache().getImage();
			ImageIcon icon = new ImageIcon(img.getScaledInstance(-1,50,Image.SCALE_FAST));
			layer.setImage(img, icon);
			setVisible(false);
		}
	}
	private void onItemCloseCacnel(){
		int result = JOptionPane.showConfirmDialog( parent
			, "ύXĕ܂BLbV͏܂B낵łH"
			, "ύX̔f", JOptionPane.YES_NO_OPTION
			, JOptionPane.QUESTION_MESSAGE);
		
		if(result == JOptionPane.YES_OPTION){
			BufferedImage img = layer.getImage();
			ImageCache cache = layer.getImageCache();
			cache.reset();
			cache.add(img);
			setVisible(false);
		}
	}
}
